/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include <stdio.h>
#include <errno.h>
#include "Aff.H"
#include "Con_Wholist.H"
#include "G_Path.H"
#include "C_Pipe.H"
#include "consts.H"
#include "G_Prend.H"
#include "C_Menu.H"
#include "G_User.H"
#include "AddLog.H"

G_Path G(30*60); // 30 minutes maxi
Aff A;
Con_Wholist W;
C_Pipe P;
AddLog L("EditWholist");
G_User * Moi;

unsigned short ZePers = 0;

int Menu_1(char ch)
{
  switch(ch)
    {
    case 'b':
        {
	unsigned short src, dest;
	A.ln(); A.printnum(M_bouge_src);  src = Prend()-1;
	A.ln(); A.printnum(M_bouge_dest); dest = Prend()-1;
	A.ln();
	P.Envoie((unsigned char)'m');
	P.Envoie(src);
	P.Envoie(dest);
	P.flush();
      }  
      break;
    case 'c': return -2;
     default: return 1;
    case 'h':
      {
	int id;
	printf("Liste des users\n");
	for ( id=0; id<MAX_USERS; id++)
	  {
	    char * Pipo = W.mem->UserName[id];
	    if ( Pipo[0] )
	      printf("%s(%d) - ",Pipo,id);
	  }
	printf("\nUsers dans hash\n");
	for(id=0; id<W.mem->n_user; id++)
	  {
	    char * Pipo = W.mem->UserName[W.mem->t_user[id]];
	    if ( Pipo[0] )
	      printf("%s(%d) - ",Pipo,id);
	  }
	printf("\nListe des roumes\n");
	for ( id=0; id<MAX_ROOM; id++)
	  {
	    char * Pipo = W.mem->RoomName[id];
	    if ( Pipo[0] )
	      printf("%s(%d) - ",Pipo,id);
	  }
	printf("\nRooms dans hash\n");
	for(id=0; id<W.mem->n_room; id++)
	  {
	    char * Pipo = W.mem->RoomName[W.mem->t_room[id]];
	    if ( Pipo[0] )
	      printf("%s(%d) - ",Pipo,id);
	  }
	printf("\nYabon\n");
      }
    } 
  return 0;
}

int Menu_2(char ch)
{
  switch(ch)
    {
    case 'c':
      A.ln(); A.printnum(M_change_lig); 
      ZePers = Prend(); 
      A.ln();
      break;
    case '1': case '2': case '3':
      {
	USRINFO * Poil = W.User(ZePers);
	if ( ! Poil) 
	  {
	    printf("User non loge \n");
	    return 0;
	  }
	char * ZeChaine[3] = 
	{ 
	  Poil -> Raison, Poil->From, Poil->Doing
	};
	int taille[3]={ LG_MAX_RAISON, LG_MAX_FROM, LG_MAX_DOING };
	
	ch -= '1';
			
	char * temp = 0;
	
	if (Prend(A.GetNum(M_Q_change + ch  ),
		    A.GetNum(M_Ok_Change + ch  ),
		    temp, 
		    taille[ch],
		    ch != 1
		  ) )
	strcpy(ZeChaine[ch],temp);
      break;
      }
      case 'g': return -3;
    default: return 1;
    } 
  return 0;
}

int Menu_3(char ch)
{
  USRINFO * Poil = W.User(ZePers);
  if ( ! Poil )
    {
      printf("User pas loge\n");
      return 1;
    }
  if ( ch >= '0' && ch <= '8')
    {
      Poil->u_wholist ^= 1 << (ch - '0') ;
      return 0;
    }
  return 1;
}

char B_F(unsigned long humf)
{
  USRINFO * Poil = W.User(ZePers);
  if ( ! Poil ) return '?';
  return A.bille(Poil->u_wholist & humf);
}

void PRINT(char ou, const char * temp)
{
  /*  time_t temps;
  temps = PrendDate(time(0)); */

  USRINFO * Poil = W.User(ZePers);

  switch  ( ou )
    {
    case 1: A.printf2(temp); break;
    case 2: 
      if ( Poil )
	A.printf2(temp,ZePers, Poil->Raison, Poil->From, Poil->Doing  ); 
      else
	A.printf2(temp,ZePers, "","","");
      break;
    case 3: A.printf2(temp,B_F(1<<0), B_F(1<<1), B_F(1<<2), B_F(1<<3),
		      B_F(1<<4), B_F(1<<5), B_F(1<<6), B_F(1<<7), B_F(1<<8)
		      );break;
    default: printf("defaults\n"); 
    }
}


int (* foncs[6])(char ) = { 0, Menu_1, Menu_2, Menu_3, 0,0  };
C_Menu M(320,foncs,6,PRINT,"EditWholist");


int main(int argc, char ** argv)
{  
  if ( argc != 2 )
  {
    printf("USAGE: %s ki \n",argv[0]);
    return 1;
  }

  L.Add("*** Starting Bidouilling ***");

  Moi=new G_User(argv[1]);

  if (! Moi->D->Set(N_flags,D_admin) )
    {
      L.Add("*** !!! BAD RIGHTS !!! ***");
      delete Moi;
      return 1;
    }

  A.Reset(Moi->D->Num(N_langue),Moi->D->Num(N_cflag),Moi->D->Num(N_more));
  M.push(1);
  P.numdeuser = 0;

  printf("EDITEUR DE WHOLIST...\n");

  while (M.encours())
  {
    M.printline();
    M.GereKey();
  }

  L.Add("*** FINISHED ***");
  delete Moi;
  return 0;
}


void terminate(void)
{
  printf("Ze termine\n");
  exit(1);
}




