/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __AFF__
#define __AFF__

#include "MSG.H"
#include "MemAttach.H"
#include "consts.H"
#include <time.h>
#include <termios.h>
#include "String.H"
// #include <termio.h>

// Macro pour biller les langues ... Aller jusk'au nb de langues 
#define LGET(a) A.bille(a & 1<<0), A.bille(a & 1<<1), A.bille(a & 1<<2), A.bille(a & 1<<3) , A.bille(a & 1 <<4), A.bille(a & 1<<5),  A.bille(a & 1<<6) 

class NoClav {};   // throwed if there is a problem in input
class NoScreen {}; // throwed if there is a problem in output
class Cancel{};    // throwed if the user cancels an operation

class Aff: public MemAttach
{
private:
  char * MsgChemin;      // chemin vers les fichiers messages
  unsigned short langue; // langue choisie
  messages * m; 
  char * sav[200];
  unsigned char NbSav;
  unsigned short T_more, nblignes;
  // Pour le ChangeTerm
  int oldMin;
  tcflag_t oldCtrl;
public: 
  int num;               // num de langue, deduit de langue
  String none, hidden;
  unsigned long flag;
public:
  Aff(void);
  ~Aff(void);
  void Change_Droit(unsigned short ,unsigned short & , char );
  void Droits(unsigned short , int);
  void Droits_Croix(unsigned short,unsigned short );
  void Reset(unsigned short L_langue,unsigned long L_flag, unsigned short );
  void FreeMsg();
  char * ColourChar(char key);
  void printf2(const char * a, ...);
  int PrintFile(char * , int);
  void ln(void);
  void ln2(void);
  char bille(int );
  char croix(int );
  int Confirm(int ,int);
  void GetPasswd(int , char * );
  char * videC(const String & );
  char * GetStringColor(const char * );
  char * colorize(const char * );
  void printnum(int , ...);
  void printnumln(int , ...);
  void printheure(int, time_t);
  void printdepuis(time_t );
  char * GetNum(int );
  void beep(void) ;
  void Direct(const char *);
  void DirectMSG(const char *);
  void Direct(char );
  char * HiddenC(const String &  , int , int );
  char * HiddenN(int    , int , int );	
  char * PUSH(char * );
  void Efface(void);
  void Pause(void);
  void AddMore(int );
  void DelCar(void);
  //  void BUG(char *);
  char GetCh(void);
  void Blank(void);
  void PrintIfOk(         int, const String & );
  void PrintIfOk(const char *, const String & );
private:
  void NewMore(void); 
};

enum Num2Msg {
    M_BUG        =  1,
    M_PassMvx    =  2,
    M_PassNvx    =  3,
    M_PassReRen  =  4,
    M_PassNoMatch=  5,
    M_PassChanged=  6,
    M_ReplyTo    =  7,
    M_NoReplyTo  =  8,
    M_MecCBarre  =  9,
    M_NoXTo      = 10,
    M_NotDisable = 11,
    M_Disable    = 12,
    M_NotSG      = 13,
    M_SG         = 14,
    M_cki        = 15,
    M_ChpModif   = 16,
    M_ChpNonModif= 17,
    M_REVE       = 18,
    M_PasCacheW  = 19,
    M_CacheW     = 20,
    M_MessageRead= 21,
    M_LoogedBRM  = 22,
    M_DoNotExist = 23,
    M_FriendHere = 24,
    M_Del_Reason = 28,
    M_Protected  = 29,
    M_IsVoting   = 30,
    M_GRADES     = 31,
    M_Ignore_Post= 32,
    M_PoteIn     = 33,
    M_PoteOut    = 34,
    M_MsgDisabl  = 35,
    M_JeXkijeVe  = 36,
    M_DansFr     = 37,
    M_DansEnnemy = 38,
    M_DisableR   = 39,
    M_Xenvoyer   = 40,
    // Jusk'a 50, + ou - envoyer kekechose a kkun
    M_KIEDIT     = 48,
    M_Xrecevoir  = 50,
    // jusk'a 60, + ou - recevoir kekechose de kkun
    M_InfoCache  = 60,
    M_InfoVide   = 61,
    M_Champ1     = 62,
    M_Champ2     = 63,
    M_Champ3     = 64,
    M_KIQuickX   = 65,
    M_OkQuickX   = 66,
    M_Question   = 67,
    M_No         = 68,
    M_Yes        = 69,
    M_C_doing    = 70,
    M_C_from     = 71,
    M_C_disabl   = 72,
    M_C_adresse  = 73,
    M_C_zip      = 74,
    M_C_ville    = 75,
    M_C_pays     = 76,
    M_C_tel      = 77,
    M_C_url      = 78,
    M_C_alias    = 79,
    M_C_CV       = 80,
    
    M_Add_Comm   = 81,
    M_Nvx_Note   = 82,
    M_View_MSG   = 83,
    M_Nvx_RI     = 84,
    M_No_Ra      = 85,
    M_Ch_More    = 86,
    M_List_Room  = 87,
    M_Cop_Emb    = 88,
    M_PassRen    = 89,
    M_Profile    = 90,
    M_DebutAm    = 91,
    M_DebutQuick = 95,
    M_DebutEnne  = 99,
    M_MaxEntrees =103,
    M_Langues    =104,
    M_Lg_Comp    =105,
    M_lg_Comp2   =106,
    M_Stats      =107,
    M_Pause      =108,
    M_ListeCopain=109,
    M_Wholist    =110,
    M_WholistU   =111,
    M_WholistDb  =112,
    M_WholistDbW =113,
    M_WholistSHo =114,
    M_WholistSeul=115,
    M_WholistBarr=116,
    M_BarrePost  =117,
    M_SendTo     =118,
    M_VaRoom     =119,
    M_Confirm_LY =120,
    M_ConfirmNor =121,
    M_ConfirmKop =122,
    M_Confirm000 =123,
    M_Confirm002 =124,
    M_Confirm005 =125,
    M_Confirm010 =126,
    M_ConfirmNo  =127,
    M_Log_Msg    =128,
    M_UsexX      =129,
    M_PostNorm   =130,
    M_PostAlias  =131,
    M_PostAliasS =132,
    M_PostMove   =133,
    M_FinPost    =134,
    M_HeurePost  =135,
    M_ZapPost    =136,      
    M_Humf       =137,
    M_ToutToutLu =138,
    M_PasPost    =139,
    M_ProfDepuis =140,
    M_ProfIci    =141,
    M_ProfBarre  =142,
    M_DepuisTps  =143,
    M_ProfVrac   =144,
    M_TpsMois    =145,
    M_TpsJours   =146,
    M_TpsHeures  =147,
    M_TpsMinutes =148,
    M_TpsSecondes=149,
    M_Nvx_Pr     =150,
    M_No_Such    =151,
    M_Oublie_Pos =152,
    M_Cant_del   =153,
    M_Twited_R   =154,
    M_wh_IDLE    =155,
    M_wh_new     =156,
    M_wh_wr      =157,
    M_Twited     =158,
    M_Non_Verif  =159,
    M_RPostSujet =160,
    M_RPostAlias =161,
    M_RPostMsg   =162,
    M_RPostEnter =163,
    M_RPostAbort =164,
    M_X_ABORT    =165,
    M_Recul_Post =166,
    M_Av_Post    =167,
    M_Go_Room    =168,
    M_Entrez     =169,
    M_Barre_1    =170,
    M_Barre_2    =171,
    M_Barre_3    =172,
    M_Barre_4    =173,
    M_Barre_5    =174,
    M_Twit_I     =175,
    M_Twit_D     =176,
    M_Twit_R     =177,
    M_Twit_A     =178,
    M_NOSG       =179,
    M_ReReadInfos=180,
    M_ModifInfos =181,
    M_ModifNum   =182,
    M_K1User     =183,
    M_Eff_Post   =184,
    M_Zap_Room   =185,
    M_Reset_Room =186,
    M_Old_File   =187,
    M_No_File    =188,
    M_Droit_A    =189,
    M_DoitFairePa=190,
    M_PeutFairePa=191,
    M_CourteWho  =192,
    M_LongueWho  =193,
    M_Liste_R1   =194,
    M_Liste_R2   =195,
    M_Liste_R3   =196,
    M_Liste_R4   =197,
    M_Liste_R5   =198,
    //   M_NoRoom     =199,
    M_DebutMenus =200,

    M_P_C_S_I    =237,
    M_P_C_S_S    =238,
    M_Idle_Who   =239,
    M_Coco_0     =240,
    M_Coco_1     =241,
    M_Coco_2     =242,
    M_Coco_3     =243,
    M_Coco_4     =244,
    M_Coco_5     =245,
    M_Coco_6     =246,
    M_Coco_7     =247,
    M_Coco_8     =248,
    M_Re_Post    =249,
    M_Show_Log   =256,
    M_Add_Keys   =257,
    M_Remove_Key =258,
    M_Change_cl  =259,
    M_Prof_0     =260,
    M_Prof_1     =261,
    M_Prof_2     =262,
    M_Prof_3     =263,
    M_Prof_4     =264,
    M_Prof_5     =265,
    M_Prof_6     =266,
    M_Prof_7     =267,
    M_Prof_8     =268,
    M_Prof_9     =269,
    M_Prof_10    =270,
    M_Prof_NotCoc=271,
    M_Prof_Coco  =272,    
    M_Prof_Short =273,
    M_Prof_CV    =274,
    M_Prof_ICQ   =275,
    M_C_ICQ      =276,
    M_Conf_Yell  =277,
    M_Com_Assume =278,
    M_Com_Found  =279,
    M_bouge_src  =280,
    M_bouge_dest =281,
    M_change_lig =282,
    M_Q_change   =283,
    M_Ok_Change  =286,

    M_Conf_Aide  =310,
    M_Sauv_Mod   =311,
    M_Change_Chp =312,
    M_Conf_CpMv  =313,

    M_change_RI = 314,

    M_nbposts   = 349,

    M_GUsers_Nb = 360,
    M_GUsers_cal= 361,
    M_GUsers_1l = 362,
    M_GUsers_2l = 363,
    M_GUsers_src= 364,
    M_GUsers_dst= 365,
    M_GUsers_reg= 366,
    M_GUsers_ere= 367,
    M_GUsers_afl= 368,
    M_GUsers_eff= 369,

    M_NotValid   = 380,
    M_ValidUser  = 381,
    /*  M_AIDEUR     = 27,
    M_VERIFIEUR  = 28,
    M_ROOMS      = 29,
    M_USERS      = 30,
    M_KICK       = 31,
    M_ADMIN      = 32,*/

    M_Medor_Deb  = 400, // les msg 400 a 420 te sont reserves, 
    M_Medor_Fn   = 420  // fait en ce ke tu veux :o)
    // Note: si tu veux fair des gros messages (plusieurs lignes)
    // Utilise la fontion printf2() plutot (msgs dans le rep Fr/ ... )
    // Dans ce cas, fait commencer tes fichiers par Medor
    // Exemple: MedorKick

};

#endif

