/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

/*
  See Debug.H for infos about this class 
*/

#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <errno.h>
#include "Debug.H"

extern int errno;
extern const char *sys_errlist[];
int forget_debug = 0;

void Debug(int level, const char * p, ...)
{
  if ( level < forget_debug ) return;
  va_list ap;

  va_start(ap, p);
  vprintf(p,ap);
  va_end(ap); 
}

void Debug_Error(int level, const char * p, ...)
{
  if ( level < forget_debug ) return;
  printf("%s: ",sys_errlist[errno]);
  va_list ap;

  va_start(ap, p);
  vprintf(p,ap);
  va_end(ap);   
}
