/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "G_Hash.H"
#include <string.h>

/*
  Generik hashtable ,
  see H_Hash.H for more info */

G_Hash::G_Hash(LAWHOLIST a)
  :m(a)
{
}
 
// Get Indexed string
char * G_Hash::I_Str(unsigned short i) const
{
  return Str(table(i));
}

int G_Hash::match(const char * prem, const char * deux)
{
  //const char * p=deux, * q=prem;
  //  printf("JE mate %s et %s \n",p,q);
  //while ( *p && *q && ( *p == *q ) ) { p++; q++; }
  // matches only if we arrived at the end of prem while always matching 
  // with the beginning of prem
  //  if ( * p ) printf("Me suis arrete a %s\n",p);
  //return ( ! ( *p ) );
  //return ( strspn(deux,prem) == strlen(deux) );
  return (prem == strstr(prem,deux));
}

// look for name and return num
unsigned short G_Hash::rechercher(const char *nom) const
{
  int i;
  for(i=index(nom[0]); i< nb(); i++)
    {
      if ( strcmp( nom, I_Str(i) )<=0 ) break;
    }
  return (strcmp(nom,I_Str(i))? 0: table(i) ) ;
}

// Try to complete name 'nom', 'it' try
char * G_Hash::complete(const char *nom, unsigned short it)
{
  unsigned char  first = nom[0];
  unsigned short ind,j=0,i, prems;
  unsigned short suiv;
  //  printf("Hash entree: %s,%d\n",nom,it);

  if (! first ) // empty string, just take the 'it' entry
    {   
      for(i=0; j<=it; i++)
	{
	  if( ok( table(i) ) ) j++;
	  if( i >= nb() ) return 0;
	}
    } 
  else
    {
      i = index(first);
      if ( first == 255 ) suiv = nb();
      else suiv = index(first+1);
      
      //on recherche la 1re occurence commencant par nom

      for(; ! match(I_Str(i),nom) ; i++)
	if( i >= suiv ) return 0; //yen a pas 
      ind = i;
      
      //on cherche la it eme occurence
      prems = i;
      do
	{
	  if ( ! match( I_Str(i), nom ) )
	    {
	      i= ind;//si on a depasse la derniere, on reprends au debut
	    }
	  else //sinon on continue
	    {                
	      if ( ok( table(i) )  )  j++;
	      i++;
	    }
	  if ( i == prems ) return 0; // Ca existe pas ...
	} while( j<=it );
    }
  //  printf("Ya 1 sortie: %s\n",I_Str(i-1));
  return( I_Str(i-1)  );
}

