/* ***************************************************************** *
 * G_Path                                                            *
 * ----------------------------------------------------------------- *
 * Version . . . . . . . . . . . . . . . . . . . . . . . . . . 1.1.0 *
 * ================================================================= *
 * Creation date . . . . . . . . . . . . . . . . . . ??? ?? ??? 1997 *
 * Modification date . . . . . . . . . . . . . . . . Sun 11 Oct 1998 *
 * ================================================================= *
 * Copyright (C) 1997-1998 Free Software Foundation, Inc.            *
 *                                                                   *
 * This program  is  free software;  you can  redistribute it and/or *
 * modify it  under the terms  of the GNU  General Public License as *
 * published by  the Free Software Foundation;  either version 2, or *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program  is distributed in the hope  that it will be useful, *
 * but WITHOUT  ANY WARRANTY;  without even  the implied warranty of *
 * MERCHANTABILITY  or  FITNESS  FOR A  PARTICULAR PURPOSE.  See the *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along  with  this  program;  if not,  write to  the Free Software *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         *
 *                                                                   *
 * ================================================================= *
 * Authors                                                           *
 *   Gregory VANDENBROUCK <vdb@pipo.com>                             *
 *   Sebastien APERGHIS-TRAMONI <saper@esil.univ-mrs.fr>             *
 *                                                                   *
 * If you find any bug, or if you do any improvment, please send us  *
 * a mail (possibly with diff and/or correction).                    *
 *                                                                   *
 * ***************************************************************** */


#ifndef __G_PATH__
#define __G_PATH__

/* ***************************************************************** *
 * standard includes                                                 *
 * ***************************************************************** */
#include <stdio.h>
#include "String.H"


/* ***************************************************************** *
 * classes                                                           *
 * ***************************************************************** */
class G_Path 
{
public:
  G_Path          (int);
    
  int             SetTimeOut      (int);
  char *          GetBinHome      (char * file);
  char *          GetEtcHome      (char * file);
  char *          GetEtcHome      (char * dir, char * file);
  char *          GetUsrHome      (char * file);
  char *          GetUserRep      (char * file);
  char *          GetServerApp    (void);
  char *          GetClientApp    (void);
  const char *    GetProprio      (void); 
  char *          GetUserFile     (const String & , const char *);
  char *          GetCommFile     (void);
  char *          GetCommFile     (int);
  char *          GetCommFile     (const char *);   
  char *          GetEmote        (char);
  char *          GetRoomFile     (const char *, int);
  char *          GetRoomInfo     (unsigned short, unsigned long);
  FILE *          GetKHFile       (const char *, const char *);
  char *          GetLogFile      (const char * );
  FILE *          AppendLogFile   (const char *);
  unsigned int    Nblg            (void);
  char *          Lg              (int);
};

#endif 



