/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "MemAttach.H"
#include <sys/ipc.h>
#include <sys/shm.h>
#include "G_Path.H"

extern G_Path G;

MemAttach::MemAttach(key_t cle, int taille)
 :MEM(0)
{
  if (( shmid = shmget ( ftok(G.GetProprio(),cle), taille, 0 )) == -1 )
    {
      perror("MemAttach::MemAttach(shmget)");
      throw MemProbs();
    }
  
  if (( MEM = (void *)shmat(shmid,0,0 )) == ( void * )-1)
    {
      perror("MemAttach::MemAttach(shmat)");
      throw MemProbs();
    }
}

MemAttach::~MemAttach(void)
{
  if ( MEM )
    if ( (shmdt((char * )MEM) == -1 ) )
      {
	perror("MemAttach::~MemAttach(shmdet)");
	throw MemProbs();
      }
}

