#include "String.H"
#include <string.h>

String::String(const char * a)
{
  if (a) val = (char *)strdup(a); else val = 0;
}

String::String(void)
  :val(0)
{
}

void String::Set(const char * a )
{
  efface();
  if (a) val = (char *)strdup(a);
}

String::String(const String & a)
{
  Set(a.val);
}

String & String::operator =  (const String &     y)
{
  Set(y.val);
  return * this;
}

unsigned int String::length(void) const
{
  if ( ! val ) return 0; 
  return strlen(val);
}

void String::SetCar(unsigned int i, char a)
{
  if ( i> length() ) return;
  val[i]=a;
}

void String::efface(void)
{
  if (val) delete [] val;
  val = 0;
}

String::~String()
{
  efface();
}

int String::operator== (const String & a ) const
{
  return (! (strcmp(data(),a.data())));
}

char String::operator[] (unsigned int i) const
{
  if (i>length()) return 0;
  return val[i];
}

const char * String::data(void) const
{
  if (val) return val;
  return "";
}

int String::null(void) const
{
  return (val == 0);
}

String String::operator+(const String & a) const
{
  char * temp = new char[length() + a.length() +1];
  strcpy(temp,data());
  strcat(temp,a.data());
  String * b = new String(temp);
  delete [] temp;
  return *b;
}
