/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include <strings.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>

#include "uread.H"
#include "Debug.H"

#define NONDELIMITEUR(c) ((c)!=' '&&(c)!='\t'&&(c)!='='&&(c)!=':'&&(c)!='\n'&&(c)!='\0')
#define NONTERMINATEUR(c) ((c)!='\n'&&(c)!='\0')
#define BLANC(c) ((c)==' '||(c)=='\t')

int FileInfo::LitChamp()
// Si le champs existe, stocke contenu dans chaine
{
  if (match2(0))
  {
    D->SetSt(CleEnCours, ChaineResult);
    return 1;
  }
  return 0;
} 

int FileInfo::LitNbre()
// Si le champ existe, modifie le nbr ...
{
  if (match2(0))
  {
    D->SetNum(CleEnCours - D->NL() - D->NC() , atoi(ChaineResult));
    delete [] ChaineResult;
    return 1;
  }  
  return 0;
}

int FileInfo::LitListe()
// Si le champ existe, modifie nbre ...
{
  return match2(D->L(CleEnCours-D->NC()));
}

void FileInfo::Proceed()
{
  int trouve;

  switch ( comment )
  {
    case k_Read: while(fgets(buffer,CHAR_LEN_LARGE,f))
    {
      buffer[strlen(buffer)-1]=0;
      trouve=0;
      if (buffer[0])
      {
        for (CleEnCours=0; CleEnCours<D->NC(); CleEnCours++ ) 
        if (LitChamp()) { trouve=1; break; }

        if (!trouve) for 
	  (CleEnCours=D->NC();CleEnCours<D->NC()+D->NL();CleEnCours++)
        if (LitListe()) { trouve=1; break; }

        if (!trouve) for (CleEnCours=D->NC()+D->NL();CleEnCours<D->total();CleEnCours++)
        if (LitNbre()) { trouve=1; break; }

        if (!trouve) Debug(1,"WARNING: \"%s\" non traite \n",buffer);
      }
    } break;
    case k_Write:
    {
      unsigned int i;
      for (i=0;i<D->NC();i++) if (D->St(i).length())
        fprintf(f,"%s = %s\n",D->Cle(i),D->St(i).data());
      for (i=0;i<D->NN();i++) if (D->Num(i))
        fprintf(f,"%s = %ld\n",D->Cle(i+D->NL()+D->NC()),D->Num(i));
      for (i=0;i<D->NL();i++) if (D->L(i)->size())
      {
        fprintf(f,"%s =",D->Cle(D->NC()+i));
        for (int j=0;j<D->L(i)->size();j++) 
	  fprintf(f," %hd",D->L(i)->DATA[j]);
        fprintf(f,"\n");
      }
    } break;
    default: Debug(3,"Pas de cas dans Proceed()\n");
  }
}

FileInfo::FileInfo(
  char * nom,  
  TypeLecture Lcomment,  // Lecture, ecriture
  Dat * DD)
  :comment(Lcomment),D(DD)
{ 
  if (!(f=fopen(nom,Lcomment==k_Write?"w":"r")))
  {
    Debug_Error(2,"FileInfo::FileInfo fichier = %s\n",nom);
    throw FileProbs();
  }
  
  if (Lcomment==k_Read) D->MetNull();
 
  delete [] nom;
  signal(SIGTERM,SIG_IGN);
}

FileInfo::~FileInfo(void)
{
  if (f) fclose(f);
  signal(SIGTERM,SIG_DFL);
}

int FileInfo::match2(LISTE * ll)
{
  char *p,*p2;
  const  char * cle=D->Cle(CleEnCours);
 
  p=buffer;
  while BLANC(*p) p++;
  p2=p; 
  while NONDELIMITEUR(*p2) p2++;

  if (strncmp(p,cle,p2-p)) return 0;

  p=p2;
  while BLANC(*p) p++;
  p++;

  if (ll)
  {
    while BLANC(*p) p++;
    p2=p;
    while NONTERMINATEUR(*p)
    {
      while NONDELIMITEUR(*p2) p2++;
      char * temp;
      temp=new char[p2-p+1];
      for (int i=0;i<p2-p;i++) temp[i]=p[i];
      temp[p2-p]=0;
      ll->Ajoute(atoi(temp));
      delete [] temp;
      while BLANC(*p2) p2++;
      p=p2;
    }
  } else 
  {
    if BLANC(*p) p++;
    ChaineResult = new char[strlen(p)+1];
    strncpy(ChaineResult,p,strlen(p)+1);
  }
  return 1;
}







