/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __WHOLIST__
#define __WHOLIST__

#include <sys/types.h>
#include "MAX.H"
#include "SERVEUR_CONSTS.H"
#include "SERVEUR_STATS.H"

typedef struct
{
  char OQP;                    // Says if the slot is taken or not
  time_t last;                 // last action time ( to know when IDLE )
  time_t login;                // login time
  unsigned short comprises;    // language understood
  unsigned long  u_rights;     // What is he allowed to do
  unsigned long  u_options;    // What are his options
  unsigned long  u_wholist;    // Wholist flags ( posts, helper, ... )
  unsigned short u_room;       // The room where he posts
  char From[LG_MAX_FROM+1];    // where he is logged from
  char Doing[LG_MAX_DOING+1];  // what is his doing
  char Raison[LG_MAX_RAISON+1];// Why he is disabled
  unsigned short nbamis,nbennemis; // nb friends, ennemies
  unsigned short AM[MAX_AM];   // Friends
  unsigned short ENN[MAX_ENN]; // Ennemies
  unsigned short nbusr;        // nb persons he is talking to
  unsigned short ZeUSR[MaxUSR];// the persons he is talking to
} USRINFO;

typedef struct
{
  unsigned short flags;     // flags divers et varies 
  //  time_t last; // utile ou pas ?
  unsigned short comprises; // langue parlee sur la roume
  unsigned short INVITED[MAX_INVITED]; // users invites
  unsigned short NB_Invited; // nb pers invitees
  unsigned short NB_Ra;      // number of Ras
  unsigned short RA[MAX_RA]; // the RAs
} ROOMINFO;

typedef struct 
{
  unsigned short Abone[MAX_ABONES_LISTE];
  unsigned short NB_Abones; 
} LISTEINFO;

typedef struct
{
  // wholist
  unsigned short nbpers;                   // logged persons
  unsigned short ki   [MaxWholistTaille];  // who is logged
  unsigned short place[MaxWholistTaille];  // where is the user info
  USRINFO Infos[MaxWholistTaille];         // A user info
  // Users
  char UserName[MAX_USERS][LG_NOM_USER+1]; // user names
  // Rooms
  ROOMINFO Rooms[MAX_ROOM];                // Room Infos
  char RoomName[MAX_ROOM ][LG_NOM_ROOM+1]; // Room names
  // Lists
  LISTEINFO Listes[MAX_LISTE];             // List Infos
  char ListName[MAX_LISTE][LG_NOM_LISTE+1];// List names
  // Constantes variables ( hin )
  unsigned long DAT[NB_ser_int];           // server consts /etc/serveur
  char St[NB_ser_chaines][60+1];           // server strings /etc/serveur
  // statistiques
  unsigned long Stat[NB_Stat];
  // Hahstable
  // 1 - users
  unsigned short i_user[256];              // index for users_names
  unsigned short n_user;                   // number of users
  unsigned short t_user[MAX_USERS];        // table for users
  // 2 - rooms
  unsigned short i_room[256];              // index for room_names
  unsigned short n_room;                   // number of rooms
  unsigned short t_room[MAX_ROOM];         // table for rooms
  // 3 - lists ( to do )
  time_t server_boot;
} lawholist, * LAWHOLIST;

const char CLEWholist = 'w';

#endif

