/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include <pwd.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <time.h>
#include "C_User_C.H"
#include "consts.H"
#include "edit.H"
#include "C_wholist.H"
#include "Aff.H"
#include "C_Prend.H"
#include "C_Liste.H"
#include "C_room.H"
#include "C_Pipe.H"
#include "C_Menu.H"
#include "G_Prend.H"
#include "G_Path.H"
#include "Profile.H"
#include "EditFile.H"
#include "ERROR.H"
#include <signal.h>
#include "TAG.H"
#include "Map.H"
#include "G_Context.H"
#include "SERVEUR_CONSTS.H"
#include "Passwd.H"
#include "GetLogFile.H"
#include "Debug.H"
#include "EffacerCompte.H"

#define VDBxxxSAM

extern const char * infos;
int num_barre = 0;

int yabon = 2;

C_User_C * Moi;
G_Path G(11*60*60); // 11 heures, puis jette .
Aff A;
C_wholist W;
Map B;
G_Context C; 
C_Pipe P; 

#ifdef VDBxxxSAM

int debiloux(void)
{
  return ( Moi->numdeuser == 20 || Moi->numdeuser == 22 );
}

#endif

int PrendUsers(int numero)
{
  int i = PrendU(numero,Moi->D->L(L_friends), Moi->D->Num(N_flags),
		 Moi->numdeuser );
  if ( ! i ) 
    { 
      A.printnumln(M_NoXTo); 
      throw Cancel();
    }
  
  return i;
}

extern C_room * ZeRoom; // La room dans lakelle on se trouve 

void AffTagScore(int n,int signe)
{
  int thescore = Moi->D->Num(N_TagSc);
  int i = W.mem->DAT[n];
  if ( signe ) i=-i;
  int newscore ;
  if ( i < 0 && -i > thescore ) newscore=0;
  else newscore = thescore + i;
  Moi->D->SetNum(N_TagSc,newscore);
  A.printnumln(M_Coco_8,thescore,i,newscore);
}

const char * Pr_Champ(int i)
{ return Moi->D->St(i).data(); }

void ChangePasswd()
{
  char PASSWD1[50+1],PASSWD2[50+1];

  A.GetPasswd(M_PassRen,PASSWD2);

  if (! test_passwd("client",Moi->Nick.data(),PASSWD2) )
    { 
      A.printnum(M_PassMvx); 
      return; 
    }

  A.GetPasswd(M_PassNvx  ,PASSWD1);
  A.GetPasswd(M_PassReRen,PASSWD2);

  if((strcmp(PASSWD1,PASSWD2))) 
    { 
      A.printnum(M_PassNoMatch); 
      return; 
    }

  set_passwd("client",Moi->Nick.data(),PASSWD1);
  A.printnumln(M_PassChanged);
}
 
int NValid()
{
  int nvalid = Moi->NotValid();

  if ( ! nvalid ) return 0;

  A.printf2("Valid");

  if ( nvalid & 1 ) A.printnumln(M_Twit_I);
  if ( nvalid & 2 ) A.printnumln(M_Twit_D);

  A.PrintIfOk(M_Twit_R,Moi->D->St(C_TwitR));
  A.PrintIfOk(M_Twit_A,Moi->D->St(C_TwitA));
  return 1;
}

int ChangeWholistFlag(unsigned short ou);
char TypeDeEmote='n';  // Idem, type de emote ...
char TypeDeAdmin='x';  // Type de X admin
extern LISTE USERS;  // Liste obtenue avec la demande de X ou kick ou profile ...

static int X2Num(char koa)
{
  switch(koa)
    {  
    case 'X': return 0; 
    case 'k': case 'K': return 1; 
    case 'd': return 2; 
    case 's': return 3; 
    case 'h': return 4; 
    case 'S': return 5;
    case 'b': return 6;
    case 'Q': return 7;
    case 'm': return 8; // mail
    case 'L': return 9; // LISTE
    }
  Debug(1,"X2Num(): type de X inconnu\n");
  return 0;
}

char * BoolChamp(int numchamp, unsigned long flag, int deplacement)
{ return A.GetNum(deplacement + (Moi->D->Set(numchamp,flag) ? 1:0 )); }

char BILLE(int numchamp, unsigned long flag)
{
  return (A.bille(Moi->D->Set(numchamp,flag) ));
}

static void Demande_de_X(unsigned char koa, unsigned char reply, unsigned short right)
{
  unsigned short ZeDernier = 0;

  if (NValid()) return;

  if ( reply=='r' || reply =='R'  )
    {
      if ( reply == 'r' )
	ZeDernier = Moi->DERNIER;
      if ( reply == 'R' )
	ZeDernier = Moi->DERNIERDERNIER;
      if (! ZeDernier) 
	{ A.printnumln(M_NoReplyTo); return; } // No one to reply
      if (!(W.connected(ZeDernier))) 
	{ A.printnumln(M_MecCBarre,W.name(ZeDernier)); return; } // Not logged
      USERS.Set(ZeDernier);
      A.printnumln(M_ReplyTo,W.name(ZeDernier)); 
    }
  else // we need to know to who to send the X
  switch (koa)
    {    
    case 'V': // Quick X
      A.printnumln(M_OkQuickX ,W.name(USERS.DATA[0]));
      koa = 'X';
      break;
    case 'Q': // Question !!!
      A.printf2("Question",W.name(Moi->SG)); USERS.Set(Moi->SG);
      break;
    case 'L':
      if ( ! USERS.size() ) 
	{ A.printnumln(M_NoXTo); return; }
      break;
    default: // normal X
      A.ln();
      PrendUsers(M_Xenvoyer+X2Num(koa));
      break;
    }
  char * leX;
  unsigned short taille;
  int ok;

  for (taille=0;taille<USERS.size();) 
    {
      unsigned short ZeUser = USERS.DATA[taille];
      ok = 1; char * tmp = W.name(ZeUser);
      if (!W.connected(ZeUser)) 
	{ 
	  A.printnumln(M_MecCBarre,tmp); ok = 0; 
	} 
      else
	{
	  if ( (W.Mine->u_wholist & W_Disabl) && 
	       ! Moi->D->L(L_friends)->cherche(ZeUser))
	    {
	      A.printf2("disabled",tmp);
	      ok = 0;
	    }
	  if ( Moi->D->L(L_ennemys)->cherche(ZeUser) )
	    {
	      A.printf2("ennemy",tmp);
	      ok = 0;
	    }
	  USRINFO *  poal = W.User(ZeUser);
	  if ( ok && (poal->u_wholist & W_Disabl) ) 
	    {  
	      ok =0;
	      A.printnumln(M_MsgDisabl,tmp);
	      if ( poal  && poal->Raison[0])  A.printnumln(M_DisableR,poal->Raison);
	      for (int k=0;k<poal->nbamis;k++) if (poal->AM[k]==Moi->numdeuser) 
		{ ok = 1; A.printnumln(M_DansFr); break; }
	      if (!ok && ( Moi->D->Set(N_flags,D_kick |D_admin ) || koa == 'h' ) ) { A.printnumln(M_JeXkijeVe); ok =1; }
	    }
	  if (ok) 
	    for (int k=0; k<poal->nbennemis;k++) 
	      if (poal->ENN[k]==Moi->numdeuser)
		{
		  A.printnumln(M_DansEnnemy,tmp);
		  if (Moi->D->Set(N_flags,D_kick | D_admin)) A.printnumln(M_JeXkijeVe); else ok=0;
		}
	}
      if (ok) taille++; else USERS.Enleve(ZeUser);  
    }

  if (! USERS.size() ) return; // plus personne a Xer ...
 
  LISTE a(MaxUSR,W.Mine->ZeUSR,&(W.Mine->nbusr));
  a.MetNull();
  a.Ajoute(USERS);

  ChangeWholistFlag(W_X);

  // printf("Envoi d'un message de type %c reply=%c droit=%d\n",koa,reply,right);
  try
    {
      switch ( koa )
	{
	case 'd':  // Message du type emote ...	  
	    leX= new char[2];
	    leX[0] = TypeDeEmote;
	    leX[1] = 0;	  
	  break;
	case 'S': // Message du type Admin ... 
	    leX= new char[4];
	    leX[0] = TypeDeAdmin;
	    leX[1] = '-';
            leX[2] = 'S';
	    leX[3] = 0;	  
	  break;
	default:
	  {
	    Editeur edit(* C.Get(X2Num(koa)));
	    leX=edit.run();
	    if (!leX)
	      {
		A.printnumln(M_X_ABORT);
		goto mouarf;
	      } else A.ln();
	  }
	  break;
	}
      Moi->SendX(USERS,koa,leX,right);
      delete [] leX;
      
      // C'est laid, rien a battre, je voulais tester le goto
      if ( USERS.cherche(Moi->numdeuser) ) goto mouarf; 
      Moi->D->Inc(N_Xe,1);
      if ( Moi->PlayCoco() ) Moi->D->Inc(N_TagSc,W.mem->DAT[N_Coco_Xs]);
    mouarf:
      a.MetNull(); 
    }
  catch ( Cancel ) {}
  ChangeWholistFlag(W_X);
}

unsigned short right_16 = 0;
unsigned char type_16   = 'X';
int reply_16            = 'n';

// correspondances options & messages de confi
const int nb_options_conf = 11;

int options_conf[nb_options_conf]=
{U_Conf_Sav,U_Conf_Mod  ,U_Conf_Pro,U_Conf_Log  ,U_Conf_Ed,U_Conf_Del,U_Conf_Stop  ,U_Conf_Zap,U_Conf_Res  ,U_Conf_Mv  ,U_Conf_Yel};
int msg_conf[nb_options_conf]=
{M_Sauv_Mod,M_ModifInfos,M_View_MSG,M_Confirm_LY,M_Nvx_Pr ,M_Eff_Post,M_Oublie_Pos ,M_Zap_Room,M_Reset_Room,M_Conf_CpMv,M_Conf_Yell};
 
void Print_Prompt2(char encours, const char * temp)
{
  switch ( encours )
    {
    case 1:
      A.printf2(temp,BILLE(N_cflag,U_expert),Pr_Champ(C_alias),
		BILLE(N_cflag,U_Barre) );
      break;  
    case 2:
      A.printf2(temp,BILLE(N_cflag,U_ansi ),
		BILLE(N_cflag,U_bold ),
		BILLE(N_cflag,U_flash), Moi->D->Num(N_more));
      break;
    case 3:
      A.printf2(temp,BILLE(N_cflag,U_Dis),BILLE(N_cflag,U_bip),Pr_Champ(C_disraison));
      break;  
    case 4:
      A.printf2(temp, Pr_Champ(C_adresse), Pr_Champ(C_zip), Pr_Champ(C_ville),
		Pr_Champ(C_pays),Pr_Champ(C_tel), Pr_Champ(C_url),
		Pr_Champ(C_CV),Moi->D->Num(N_ICQ));
      break;
    case 5:
      {
	A.printf2(temp);
	for(int i=0; i<	nb_options_conf; i++)
	  {
	    A.printnumln(M_P_C_S_S,i+'0',
			 A.GetNum(msg_conf[i]),
			 A.GetNum(M_No+(Moi->D->Set(N_cflag,options_conf[i])!=0)));
	  }
	break;
      }
    case 6:
      A.printf2(temp,BILLE(N_cflag,U_LShow),BILLE(N_cflag,U_LLShow),
		BILLE(N_cflag,U_BipCopain),
		BILLE(N_cflag,U_Dis),  BILLE(N_cflag,U_Conf_Log),
		Pr_Champ(C_host));
      break;
    case 7:
      A.printf2(temp,BILLE(N_cflag,U_LLShow),BILLE(N_cflag,U_BipCopain));
      break;
    case 11:
      {
	unsigned short l =  Moi->D->Num(N_langue);
	A.printf2("lang",LGET(l));
      }
      break;
    case 12:
      {
	unsigned short l =  Moi->D->Num(N_comprises);
	A.printf2("lang",LGET(l));
      }
      break;
    case 13:
      A.printf2(temp,BILLE(N_cflag,U_LgSay)); 
      break;
    case 16:
      A.printf2(temp,type_16,reply_16);
      A.Droits_Croix(Moi->D->Num(N_flags),right_16);
      A.printf2("client16fin");
      break;
    case 21:
      {
	char * Humf =C.Str();  
	A.printf2(temp,Humf);
	delete [] Humf;
      }
      break; 
    case 20:
      A.printf2(temp,BILLE(N_cflag,U_PTag),BILLE(N_cflag,U_PKH));
      break;
    case 22:
      A.printf2(temp,BILLE(N_cflag,U_C_name),BILLE(N_cflag,U_C_num),BILLE(N_cflag,U_C_log),
		BILLE(N_cflag,U_C_mail),BILLE(N_cflag,U_C_pays),BILLE(N_cflag,U_C_time),BILLE(N_cflag,U_C_first));
      break;
    case 23:
      A.printf2(temp,
		BILLE(N_CWhol,CW_Short), 
		Moi->D->Num(N_idle),
		BoolChamp(N_CWhol, CW_Depart, M_CourteWho),
		BoolChamp(N_CWhol, CW_Frlist, M_DoitFairePa),
		BoolChamp(N_CWhol, CW_Ennemy, M_DoitFairePa),
		BoolChamp(N_CWhol, CW_French, M_DoitFairePa),
		BoolChamp(N_CWhol, CW_English, M_DoitFairePa),
		BoolChamp(N_CWhol, CW_Spain, M_DoitFairePa),
		BoolChamp(N_CWhol, CW_Spain, M_DoitFairePa),
		BoolChamp(N_CWhol, CW_Spain, M_DoitFairePa),
		BoolChamp(N_CWhol, CW_Spain, M_DoitFairePa),
		BoolChamp(N_CWhol, CW_Spain, M_DoitFairePa)
		);
      break;
    case 17:
      A.printf2(temp);
#ifdef VDBxxxSAM
      if ( debiloux() ) 
	printf("Pour les debiloux, ya aussi: 1, h, H, a\n");
#endif
      break;
    case 8: case 26: A.printf2("liste"); break;
    default: A.printf2(temp);
    }
}

//char ch;
int modifie=0;

void Change_Champ(int NumChamp,int i)
{
  char * nomduchamp=A.GetNum(i);
  if ( Prend(nomduchamp,nomduchamp,NumChamp,
	     Moi->D,NumChamp == C_doing) )
    modifie = 1;
}

void Change_Entier(int NumEntier,int i)
{
  A.ln();
  A.printnum(i);
  Moi->D->SetNum(NumEntier,Prend());
  modifie = 1;
}

void Changecolorflag(unsigned long ou)
{ Moi->D->Swap(N_cflag,ou);  modifie=1; }

int ChangeWholistFlag(unsigned short ou)
{ 
  W.Mine->u_wholist ^= ou; 
  return ( W.Mine->u_wholist & ou ? 1:0); 
}

void EXEC(char * koa, char * prem)
{
  char * temp = G.GetBinHome(koa);

  int n = fork();
	
  if ( n== -1 ) perror("FUCK FORK");
  if ( n )
    { 
      wait(0); 
    }
  else
    { 
      execlp(temp,koa,Moi->Nick.data(),prem, 0);
      perror("EXEC");
      abort();
    }

  delete [] temp;
}

int Menu_0(char ch)
{
  ch = B.MapKey(ch);
  switch(ch)
    {
    case '@': EXEC("GereUsers",0); break;
    case '0': case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9': 
      {
	int temp = ch - '0';
	if ( temp  >= Moi->D->L(L_quick)->size() )
	  A.printnumln(M_KIQuickX);  else
	    {
	      USERS.Set(Moi->D->L(L_quick)->DATA[temp]);
	      Demande_de_X('V',0,0);		   
	    }
      }
      break;
    case '+': case '-': case ')': case '(':
      Moi->Jump_To_Room(ZeRoom->NumRoom,ch); return 2;
    case 'A': 
      if ( NValid() ) return 0;
      if ( Moi->D->Set(N_flags,D_verif | D_users | D_kick | D_admin ) ) return -10; else 
	A.printnumln(M_REVE);
      break;
    case 'a':
      if ( NValid() ) return 0;
      if ( ZeRoom->CHEF() )
	{
	  char temp[100];
	  sprintf(temp,"%d", ZeRoom->NumRoom);
	  EXEC("EditRoom",temp);
	} else A.printnumln(M_REVE);
      break;
    case 'b': ZeRoom->GoBack(2); return 2;
    case 'B':
      A.printnum(M_Recul_Post);  ZeRoom->GoBack(Prend());
      return 2;
    case 'c': return -1;
    case 'C': 
      if ( A.Confirm(M_Conf_CpMv,U_Conf_Mv) &&  ZeRoom->NumRoom >= 2 ) 
	{
	  int i = PrendRoom();
	  if ( i < 2 ) break;
	  C_room DestRoom(i,0,0);
	  DestRoom.CanPost(); // check if can post
	  Moi->CopierPost(ZeRoom->NumRoom, ZeRoom->pos,i);
	}
      break;
    case 'd': 
      if ( NValid() ) return 0;
      A.printnumln(M_NotDisable+ChangeWholistFlag(W_Disabl)); 
      break;
    case 'D':ZeRoom ->Deleter();  break;
    case 'e': case 'E':
      if ( NValid() ) return 0;
      ChangeWholistFlag(W_poste);
      try 
	{
	  ZeRoom->Poster(ch == 'E'); 
	}
      catch ( Cancel )
	{
	  ChangeWholistFlag(W_poste);
	  W.Mine->u_room = 0;
	  throw Cancel();
	}
      ChangeWholistFlag(W_poste);
      W.Mine->u_room = 0;
      break;
    case 'f':
      A.ln();
      system("/usr/games/fortune");
      break;
    case 'F':// Friends logged
      {
	LISTE a(MAX_AM), * l = Moi->D->L(L_friends);
	for (int i=0;i<l->size();i++)
	  {
	    unsigned short j = l->DATA[i];
	    if (W.connected(j)) a.Ajoute(j);
	  }
	Affiche(a,M_ListeCopain);
	break;
      }	  
      break;
    case 'g': 
      if ( A.Confirm(M_Oublie_Pos,U_Conf_Stop) ) 
	{ 
	  ZeRoom->Oublie(); Moi->Jump_To_Room(ZeRoom->NumRoom,'+'); 
	  return 2;
	}
      break;
    case 'h': case 'H': EXEC("Tutorial",0); break;
    case 'i': case 'I': ZeRoom->PrintInfo(ch); break;
    case 9: return -18; // Ctrl I
    case 'j':
      Moi->Jump_To_Room(PrendRoom(),'j'); return 2;
    case 'k':
      Moi->Liste_Roumes();
      return 2;
    case 'K': 
      {
	printf("Liste des listes ( hin )\n");
	LISTEINFO * B = & (W.mem->Listes[0]);
	for (int i=0; i< MAX_LISTE; i++)
	  {
	    int yep = 0;
	    for (unsigned char j =0; j< B->NB_Abones; j++)
	      if (B->Abone[j]==Moi->numdeuser) { yep=1; break; }
	    printf("%s(%d), %d users, %s\n",
		   W.mem->ListName[i],i,B->NB_Abones,yep?"yep":"no");
	    B++;
	  }	  
      }
      break;
    case 'l': 
      {
	int nbr = 0;
	A.ln();
	for ( int i=0; i < W.mem->nbpers; i++ )
	  {
	    unsigned short LeMec = W.mem->ki[i]; 
	    if (W.IsXing(LeMec,Moi->numdeuser)) 
	      {
		nbr ++;
		A.printnumln( M_ConfirmNor + Moi->D->L(L_friends)->cherche(LeMec),
                              W.name(LeMec));
#ifdef VDBxxxSAM
		if ( debiloux() && ( LeMec == 20 || LeMec == 22 ) )
		  {
		    A.Direct(" xxx Ton babychery te cause :o) xxx \n"); A.Direct("Mmmmmmmmmmmmmmmmmmmmmmmmm ... \n"); 
		  }
#endif
              }
	  }
	if ( !nbr ) A.printnumln(M_Confirm000); else
	  {
	    if ( nbr >  2 ) A.printnumln(M_Confirm002 );
	    if ( nbr >  3 ) A.printnumln(M_Confirm005 );
	    if ( nbr >  4 ) A.printnumln(M_Confirm010 );        
	  }
	
	if ( ! A.Confirm (M_Confirm_LY ,U_Conf_Log) ) 
	  { A.printnumln(M_ConfirmNo); break; }
	  
	// if ( yabon ++ > 2 ) yabon=0;
	Moi->Baille();
	break;
      }
    case 'L':
      {
	A.Direct("Parler a la liste num ? ");
	unsigned short k = Prend();
	A.ln();
	if ( k <  MAX_LISTE )
	  {
	    LISTEINFO * muche = & (W.mem->Listes[k]); 
	    LISTE poal(MAX_ABONES_LISTE,muche->Abone,&(muche->NB_Abones));
	    USERS.MetNull();
	    USERS.Ajoute(poal);
	    Demande_de_X('L',0,0);
	  }
	break;
      }
    case 12: // Ctrl L
      EXEC("GereListe",0);
      break;
    case ' ': case 'n': ZeRoom->GetNext(); return 2;
    case 'N':
      A.printnum(M_Av_Post); ZeRoom->GoBack(-Prend());
      return 2;
    case 'm': Moi->Jump_To_Room(1,'j'); return 2;
    case 'M': if ( A.Confirm(M_Conf_CpMv,U_Conf_Mv) )
      {
	if ( ZeRoom->NumRoom < 2 ) break;
	int i = PrendRoom();
	if ( i < 2 ) break;
	C_room DestRoom(i,0,0);
	DestRoom.CanPost(); // check if can post
	Moi->CopierPost(ZeRoom->NumRoom, ZeRoom->pos,i);
	ZeRoom->Deleter();
      }
    break;
    case 'p': case 'P': case 16: 
      if ( NValid()) return 0;
      A.ln();
      PrendUsers(M_Profile);
      for (int i=0;i<USERS.size();i++)
	{
	  G_User * a = 0;
	  if (USERS.DATA[i]==Moi->numdeuser) a = Moi;
	  else try
	    {
	      a = new G_User(W.name(USERS.DATA[i]));	
	    }
	  catch ( BadUser )
	    {
	      A.printnumln(M_No_Such);
	    }
	  if ( a )
	    {
	      Profile Pr(a);
	      Pr.View(ch, Moi->numdeuser,Moi->D->Num(N_flags) );
	      if ( Moi->numdeuser == 3 ) // debug pour le moment
		{
		  printf("PENSE A METTRE CA POUR TOUS USERS !\n");
		  char temp[100];
		  sprintf(temp,"ping -c 3 %s",a->D->St(C_last).data());
		  //		      system(temp);
		}
	      if (a!=Moi) delete a;
	    }
	}
      break;
    case 'q': case 'Q': 
      Moi->SG = W.Look_for_SG(Moi->numdeuser, Moi->SG);
      if (  Moi->SG ) Demande_de_X('Q',0,0); else A.printnumln(M_NOSG);
      break;
    case 'r': case 'v': Demande_de_X('X','r',0); break;
    case 'R':  Demande_de_X('X','R',0); break;
    case 's': 
      printf("Skip!\n");
      Moi->Jump_To_Room(ZeRoom->NumRoom,'+'); 
      return 2;
    case 'S': if ( ++num_barre == 5 ) num_barre=0; break;
    case 't':
      {
	A.ln();
	system("uptime");
        printf("Client compilation time: %s %s\n",
	       __DATE__,__TIME__);
	printf("Number of logins since last reboot: %d\n",
	       W.mem->Stat[N_ser_login]);
	
	A.PrintFile(G.GetEtcHome("serveur"),1);
      }
      break;
    case 'T': 
      Moi->SendTag(); 
      return 2;
    case 20: // Ctrl T
      {
	char * p = 0;
      
	Prend((char *)0,"Coco Texte",p,60);

	if ( p ) 
	  { 
	    strcpy(W.St(C_CocoTexte),p);
	    delete [] p;
	  }
      }
      break;
      //case 'v': Maintenant, r ...  
    case 'V':      
      if ( W.IsAVote() )
	{
	  A.printnumln(M_IsVoting);
	}
      else
	{
	  ChangeWholistFlag(W_Vote);     
	  EXEC("Vote",0);
	  ChangeWholistFlag(W_Vote);
	}
      break;
    case 22: // Ctrl V
      A.PrintFile(G.GetEtcHome("VOTE"),1);
      break;
    case 'w': case 'W': case 23: 
      {
	W.Affiche(ch); 
	break;
      }
    case 'x': Demande_de_X('X',0,0); break;
    case 'X': return -16;
    case 24: Moi->Jump_To_Room(0,'j'); return 2;
    case 'y': case 'Y': return -9;
    case 'z': 
      if (A.Confirm( M_Zap_Room, U_Conf_Zap )) 
	{
	  LISTE a(1);
	  a.Ajoute(ZeRoom->NumRoom);
	  Moi->ZapRoom(a);
	  Moi->Jump_To_Room(ZeRoom->NumRoom,'+');
	  return 2;
	}
      break;
    case 'Z': if ( A.Confirm (M_Reset_Room,U_Conf_Res ) ) 
      { 
	ZeRoom->SetPos(0); 
	ZeRoom->GetNext(); 
      }
    break;
    case 26: //Zapp all rooms
      {
	A.Direct("ALL ROOMS ZAPPED !!!\n");
	LISTE a(MAX_ROOM);
	for (int i=11;i<MAX_ROOM;i++)
	  a.Ajoute(i);
	Moi->ZapRoom(a);
	Moi->Jump_To_Room(2,'j');
      }
      break;
    case '!': Demande_de_X('s',0,0); break;
    case '~': return -17;
    case '$': return -27;
    case '<': return - 7; 
    case '>': return - 8; 
    case '%': 
      {
	if ( NValid()) return 0;
	if (Moi->D->Set(N_flags, D_help) )
	  A.printnumln(M_NotSG+ChangeWholistFlag(W_Help));
	else A.printnumln(M_REVE);
      }
      break;       
    case '?': return -25;  break;
    case 18: A.Efface();  break;
    case '\n': return 2;
    default: return 1; 
    }
  return 0;
}

int Menu_1(char ch)
{
  switch(ch)
    {
    case 'a': Change_Champ(C_alias,M_C_alias); break;
    case 'b': Changecolorflag(U_Barre); break;
    case 'c': ChangePasswd(); break;
    case 'd': Change_Champ(C_doing,M_C_doing); break;
    case 'e': return - 2;
    case 'E': return -21;
    case 'f': Change_Champ(C_from,M_C_from);   break;
    case 'g': return -20;
    case 'h': return -22;
    case 'i': return - 4; 
    case 'l': return -13;
    case 'n': return -5;
    case 'M': return -19;
    case 'o': return -6;
    case 'p': EditFile(G.GetUserFile(Moi->Nick,"profile"),M_Nvx_Pr,50,O_WRONLY | O_TRUNC); break;
    case 'v': Changecolorflag(U_expert); break;
    case 'V': GetLogFile(Moi->Nick.data()); break;
    case 'w': return -23;
    case 'x': return - 3;
    case 'I': return -26; 
    default: return 1;
    }
  return 0;
}

int Menu_2(char ch)
{
  switch(ch)
    {
    case '1': Changecolorflag(U_ansi); break;
    case '2': Changecolorflag(U_bold); break;
    case '3': Changecolorflag(U_flash);break;
    case 'p': Change_Entier(N_more,M_Ch_More); break;
    default: return 1;
    }
  return 0;
}

int Menu_3(char ch)
{
  switch(ch)
    {
    case '1': Changecolorflag(U_Dis); break;
    case '2': Changecolorflag(U_bip); break;
    case 'a': return -7; 
    case 'e': return -8; 
    case 'r': Change_Champ(C_disraison,M_C_disabl); break;
    default: return 1;
    }
  return 0;
}

int Menu_4(char ch)
{
  switch(ch)
    {
    case 'a': Change_Champ(C_adresse,M_C_adresse); break;
    case 'z': Change_Champ(C_zip,M_C_zip); break;
    case 'v': Change_Champ(C_ville,M_C_ville); break;
    case 'y': Change_Champ(C_pays,M_C_pays); break;
    case 't': Change_Champ(C_tel,M_C_tel); break;
    case 'u': Change_Champ(C_url,M_C_url); break;
    case 'c': Change_Champ(C_CV,M_C_CV); break;
    case 'i': Change_Entier(N_ICQ,M_C_ICQ); break;
    default: return 1;
    }
  return 0;
}


int Menu_5(char ch)
{
  if ( ch >= '0' && ch <= '0'+nb_options_conf )
    {
      Changecolorflag(options_conf[ch-'0']);
      return 0;
    }
  return 1;
}

int Menu_6(char ch)
{
  switch(ch)
    {
    case 'a': Changecolorflag(U_LLShow); break;
    case 'b': Changecolorflag(U_BipCopain); break;
    case 'c': Changecolorflag(U_Conf_Log); break;
    case 'm': Changecolorflag(U_LShow); break;
    case 'x': Changecolorflag(U_Dis); break;
    case 'h': Change_Champ(C_host,M_C_from); break;
    default: return 1;
    }
  return 0;
}

int Menu_7(char ch)
{
  switch(ch)
    {
    case 'a': case 'r': case 'l': case 'c':
      Gere(Moi->D->L(L_quick),ch,M_DebutQuick); modifie=1;
      break;
    case 'A': case 'R': case 'L': case 'C':
      Gere(Moi->D->L(L_friends),ch-('A'-'a'),M_DebutAm); modifie=1;
      break;
    case 'v': Changecolorflag(U_LLShow); break; 
    case 'b': Changecolorflag(U_BipCopain); break;
    default: return 1;
    }
  return 0;
}

int Menu_8(char ch)
{
  switch(ch)
    {
    case 'a': case 'r': case 'l': case 'c':
      Gere(Moi->D->L(L_ennemys),ch,M_DebutEnne); modifie=1;
      break;
    default: return 1;
    }       
  return 0;
}

int Menu_9(char ch)
{  
  switch(ch)
    {
    case 'Y':
      A.printf2("Yell");
      if ( A.Confirm(M_Conf_Yell,U_Conf_Yel) )
	{
	  unsigned short LaRoom = ZeRoom ->NumRoom, 
	    pos=ZeRoom->pos, 
	    totalpos=ZeRoom->TotalPost;
	  
	  if ( ZeRoom ) delete ZeRoom;
	  ZeRoom = new C_room(8,0,0);
	  ZeRoom->Poster(0);
	  delete ZeRoom;
	  ZeRoom = new C_room(LaRoom,pos,totalpos);
	}
      break;
    case 'E':
      {
	LISTE a(1);
	a.Ajoute(Moi->numdeuser);
	EffacerCompte(a);
      }
      break;
    case 'C': case 'H': case 'S':
      printf("Not yet implemented ...\n");
      break;
    default: return 1;
    }       
  return 0;
}

int Menu_10(char ch)
{
  switch(ch)
    {
    case 'u': if (Moi->D->Set(N_flags, D_users | D_verif | D_kick ) ) 
      return -15;
    case 's': if (Moi->D->Set(N_flags, D_admin )) return -14;
    case 'w': if (Moi->D->Set(N_flags, D_admin )) EXEC("EditWholist",0); break;
    case 'b': if (Moi->D->Set(N_flags, D_admin )) Demande_de_X('b',0,0); break;
    default: return 1;
    }
  return 0;
}

int Menu_11(char ch)
{
  if (ch>='1' && ch <='1'+G.Nblg())
    {
      Moi->D->SetNum(N_langue , 1 << (ch - '1'));
      modifie=1; 
      return 0;
    } 
  return 1;
}

int Menu_12(char ch)
{
  if (ch>='1' && ch <='1'+G.Nblg())
    {
      Moi->D->Swap(N_comprises, 1 << (ch -'1')); 
      modifie=1;
      return 0;
    } 
  return 1;
}

int Menu_13(char ch)
{
  switch(ch)
    {
    case 'm': return -11; 
    case 'c': return -12;
    case 'a': Changecolorflag(U_LgSay); break;  
    default: return 1;
    }
  return 0;
}

int Menu_14(char ch)
{
  switch(ch)
    {
    case 'r': Moi->Reboot(); break; 
    case 'h': A.printnumln(M_PasCacheW+ChangeWholistFlag(W_Hidden)); break;
    case 'n': Moi->LoadMsg(); break;
    case 'c': Moi->LoadConfig(); break;
    default: return 1;
    }
  return 0;
}

int Menu_15(char ch)
{
  switch(ch)
    {
    case 'e':
      {
	if ( PrendUsers(M_KIEDIT) > 1 ) A.printnumln(M_K1User);
	
        EXEC("EditUser",W.name(USERS.DATA[0]));
      }
      break;
    case 'd':
      PrendUsers(M_KIEDIT);
      EffacerCompte(USERS); 
      break;
    case 'k': case 'K': 
      if ( Moi->D->Set(N_flags,D_kick)) Demande_de_X(ch,0,0); 
      break;
    case 'b':
      EditFile(G.GetEtcHome("Users"),M_Nvx_Pr,200,O_WRONLY | O_TRUNC);
      break;
    default: return 1;
    } 
  return 0;
}



int Menu_16(char ch)
{
 
  if ( ch >='0' && ch <=';')
    {
      A.Change_Droit(Moi->D->Num(N_flags),right_16,ch);     
      return 0;
    }

  switch(ch)
    {
    case 'X': case 'd': case 's': type_16 = ch; break;
    case 'h': if (Moi->D->Set(N_flags, D_help)) type_16 = ch; else A.printnumln(M_REVE); break;     
    case 'k': case 'K': if ( Moi->D->Set(N_flags,D_kick)) type_16 = ch; else A.printnumln(M_REVE); break;
    case 'n': case 'r': case 'R': reply_16 = ch; break;
    case 'G': Demande_de_X(type_16,reply_16,right_16); break;
    default: return 1;
    }
  return 0;
}

int Menu_17(char ch)
{
  switch(ch)
    {
    case 'B': case 'D': case 'F': case 'G': case 'N': case 'P': case 'R': case 'T': case 'b': case 'd': case 'f': case 'k': case 'l': case 'n': case 'p': case 'r': case 's': case 'u': case 'L': case 'v':  case 'S':
    case 'a': case '1': case 'h': case 'H':
      TypeDeEmote=ch;
      Demande_de_X('d',0,0);
      break; 
    default: return 1;
    }
  return 0;
}

int Menu_18(char ch) // Copyrights
{
  switch ( ch )
    {
    case 'O':
      A.Direct(CopyrightNames);
      A.GetCh();
      break;
    case 'C':
      A.Direct(Copyright);
      A.GetCh();
      break;
    case 'L':
      A.Direct(LocalCopyright);
      A.GetCh();
      break;
    case 'Y':
      A.Direct(A.GetStringColor("COPYING"));
      break;
    default: return 1;
    }
  return 0;
}

int Menu_19(char ch)
{
  switch(ch)
    {
    case 'a':    
      A.printnum(M_Add_Keys);
      Moi->D->SetSt(C_map,B.AddKey(A.GetCh(),A.GetCh()));
      modifie = 1;
      break;
    case 'r':
      A.printnum(M_Remove_Key);
      Moi->D->SetSt(C_map,B.RemoveKey(A.GetCh()));
      modifie = 1;
      break;
    case 'l':
      B.ListKeys();
      break;
    default: return 1;
    }
  return 0;

}


int Menu_20(char ch) // Jeux
{
  switch(ch)
    {
    case '1': Changecolorflag(U_PTag); break; 
    case '2': Changecolorflag(U_PKH); break;  
    default: return 1;
    }
  return 0;
}

int Menu_21(char ch) // Couleurs
{
  if ( ch >= '0' && ch < '0' + C.Nb() )
    {
      ch -= '0';
      A.printnum(M_Change_cl);
      C.SetEntry(ch,A.GetCh());
      Moi->D->SetSt(C_color,C.Str());
      modifie = 1;
      return 0;
    }
  return 1;
}

int Menu_22(char ch)
{
  switch(ch)
    {
    case '1': Changecolorflag(U_C_name); break;    
    case '2': Changecolorflag(U_C_num ); break;    
    case '3': Changecolorflag(U_C_log ); break;    
    case '4': Changecolorflag(U_C_mail); break;    
    case '5': Changecolorflag(U_C_pays); break;    
    case '6': Changecolorflag(U_C_time); break;    
    case '7': Changecolorflag(U_C_first);break;    
    case 'H': 
      Moi->D->SetNum(N_cflag, Moi->D->Num(N_cflag) | 
		     ( U_C_name+U_C_num+U_C_log+			      
		       U_C_mail+U_C_pays+U_C_time+U_C_first ));
      modifie=1; 
      break;             
    default: return 1;
    }
  return 0;
}

int Menu_23(char ch)
{
  switch(ch)
    {
    case 'l': Moi->D->Swap(N_CWhol, CW_Short); modifie = 1; break;
    case 'v': Change_Entier(N_idle,M_Idle_Who); break;
    case 'd': Moi->D->Swap(N_CWhol, CW_Depart); modifie = 1; break;
    case '1': case '2': case '3': case '4': case '5':
      Moi->D->Swap(N_CWhol, 1 << (ch - '0' +1));
      modifie = 1;
      break;
    default: return 1;
    }
  return 0;
}

int Menu_24(char ch)
{
  printf("FAIRE LE MENU COCO BOUTIQUE !!!\n");
  
  switch(ch)
    {
      break;
    default: return 1;
    }
  return 0;
}

int Menu_25(char ch)
{
  if ( ch >='1' && ch <='7' )
    {
      char temp[100];
      sprintf(temp,"ShortH%d",ch-'0');
      A.printf2(temp);
      A.GetCh();
      return 0;
    }
  return 1;
}

int Menu_26(char ch)
{
  switch(ch)
    {
    case 'a': case 'r': case 'l': case 'c':
      Gere(Moi->D->L(L_ignore),ch,M_DebutEnne); modifie=1;
      break;
    default: return 1;
    }       
  return 0;
}

int Menu_27(char ch)
{
  switch(ch)
    {
    case 'a': case 'A': case 'V': case 'e': case 'E': case 'D': case 'P': case 'i':
      TypeDeAdmin=ch;
      Demande_de_X('S',0,0);
      break; 
    default: return 1;
    }
  return 0;
}

int (* foncs[28])(char ) = 
{ Menu_0, Menu_1, Menu_2, Menu_3, Menu_4, Menu_5,
  Menu_6, Menu_7, Menu_8, Menu_9, Menu_10,Menu_11, 
  Menu_12,Menu_13,Menu_14,Menu_15,Menu_16,Menu_17, 
  Menu_18,Menu_19,Menu_20,Menu_21,Menu_22,Menu_23,
  Menu_24, Menu_25, Menu_26, Menu_27
};

C_Menu M(200,foncs,28,Print_Prompt2,"client");

void Deal_Modif(void)
{ 
  LISTE * a = W.RoomsRA(Moi->numdeuser);
  if (  a-> size() )
    {
      if (! Moi->D->Set(N_flags,D_1_room))
	Moi->D->Swap(N_flags,D_1_room);
    }
  else
    {
      if (Moi->D->Set(N_flags,D_1_room))
	Moi->D->Swap(N_flags,D_1_room); 
    }
  delete a;
  Moi->Lit_Sauve(k_Write);
  W.Update();
  B.Set(Moi->D->St(C_map).data());
  M.flags = Moi->D->Num(N_cflag);
  A.Reset(Moi->D->Num(N_langue),Moi->D->Num(N_cflag), Moi->D->Num(N_more));
  C.Set(Moi->D->St(C_color).data());

  modifie = 0;
}

void AR(unsigned short c,LISTE * L)
{
  if ( ! L->size() )  return;
  A.printnum(c);
  for (unsigned short i=0; i<L->size(); i++)
    {
      if ( ! ( i%2 ) ) A.ln();
      A.printnum(M_List_Room,W.RoomName(L->DATA[i]),L->DATA[i]);
    }
  A.ln();
}

void Say_Hello(char * fromage)
{
  short i;
  W.Set(Moi);
  time_t temps=time(0); 
  tm * HEURE = localtime(&temps);
  Moi->D->Inc(N_logins,1);
  
  A.ln();
  A.printf2("HelloUser",
	    Moi->Nick.data(), Moi->D->Num(N_logins), 
	    HEURE->tm_mday, HEURE->tm_mon+1, HEURE->tm_year+1900,
	    HEURE->tm_hour, HEURE->tm_min,  W.NB());
 
  if (! Moi->D->St(C_last).null() )
    {
      temps=Moi->D->Num(N_lastlog);
      HEURE=localtime(&temps);
      A.printf2("Dernier",Moi->D->St(C_last).data(),
		HEURE->tm_mday, HEURE->tm_mon+1, 
		HEURE->tm_year+1900,
		HEURE->tm_hour, HEURE->tm_min);
    } 

  if ( Moi->D->Num(N_logins) < 10 )
    A.Direct(A.GetStringColor("First"));
  
  A.PrintIfOk("welcome", Moi->D->St(C_Welcome));
  
  if ( Moi->PlayCoco() )
    Moi->D->Inc(N_TagSc,W.mem->DAT[N_Coco_Login]);
  
  A.ln();
  
  if ( Moi->D->Set(N_cflag, U_LShow) ) // On doit montrer les amis au login
    for (i=0;i<Moi->D->L(L_friends)->size();i++)
      {
	unsigned short j = Moi->D->L(L_friends)->DATA[i];
	if (W.connected(j)) A.printnumln(M_FriendHere,W.name(j));
      }
  
  if (Moi->D->Set(N_cflag, U_Dis)) 
    {
      A.printnumln(M_Disable);
      ChangeWholistFlag(W_Disabl);
    }
  
  A.ln();
  unsigned long f = Moi->D->Num(N_flags);
  if ( ! ( f & D_untwit))  ChangeWholistFlag(W_Disabl);
  if ( f &  D_help )       ChangeWholistFlag(W_Help);
  A.Droits(f,1);
  
  Moi->D->SetSt(C_last,String(fromage)); 
  if ( ! Moi->D->St(C_host).null() ) 
    Moi->D->SetSt(C_from,Moi->D->St(C_host));
  else
    Moi->D->SetSt(C_from,String(fromage));
  Moi->D->SetNum(N_lastlog,time(0));
  Moi->D->SetNum(N_logout,0);
  modifie=1;
  A.ln();
  Moi->Jump_To_Room(2,'j');

  yabon = 1; // Yes, on accpete le clav now !! 
}

void Print_X(const Un_X & a)
{
  A.ln2(); 
  char * nom = W.name(a.ki);
  if ( a.right )
    {
      A.printnum(M_GRADES);
      A.Droits(a.right,0);
    }
  
  switch ( a.type )
    {
    case 'd':
      A.printnumln(M_Xrecevoir+X2Num('d'),nom);
      A.PrintFile(G.GetEmote(a.buf[0]),1);
      break;
    case 's':
      A.printnum(M_Xrecevoir+X2Num('s'),nom); 
      A.Direct(A.colorize(a.buf));
      break;
    case '*':
      A.printnum(M_Xrecevoir+X2Num('s'),nom); 
      A.Direct(A.GetNum( 250 + a.num ));
      break;
    case 'b':
      A.beep(); 
    default:
      {
	tm * HEURE;
	time_t temps;
	temps=time(0); HEURE = localtime(&temps); 
	A.printnumln(M_Xrecevoir+X2Num(a.type),
		     nom,HEURE->tm_hour, 
		     HEURE->tm_min); 
	if (a.type == 'S' )
	  A.Direct(A.GetStringColor(a.buf));
	else
	  A.Direct(A.colorize(a.buf));
      }
    }
  
  if (Moi->D->Set(N_cflag, U_bip)) A.beep();
  
  if (a.type!='K') // On va etre kille, pas la peine
    {
      Moi->Ack(a.ki,a.type);
      if (a.type=='k') Moi->Baille();
    }
  A.ln2(); 
}

void Print_Log( const Un_log & a )
{
  M.no_print=1;
  if ( a.in )
    {
      if (Moi->D->L(L_friends)->cherche(a.ki)) 
	{
	  if ( Moi->D->Set(N_cflag, U_LLShow ))
	    { M.no_print=0; A.printnumln(M_PoteIn,W.name(a.ki)); }
	  if ( Moi->D->Set(N_cflag, U_BipCopain) ) A.beep();
	}
    }
  else
    {
      if (Moi->D->L(L_friends)->cherche(a.ki))
	if ( Moi->D->Set(N_cflag,U_LLShow ))
	  { 
	    M.no_print=0;  A.printnumln(M_PoteOut,W.name(a.ki)); 
	  }
    }
}

void Print_Medor(const Un_Medor & a )
{
  // la structure a est remplie avec le msg recu du serveur
  // Tu peux imprimer les infos en consequence
}

void Print_Tag(const Un_Tag & a )
{
  char * p = W.name(a.ki);
  A.ln();
  switch ( a.type )
    {
    case 'N':
      A.printnumln(M_Coco_0,W.mem->DAT[N_CocoMin]); // not enough players
      break;
    case 'S':
      if (  a.ki != Moi->numdeuser )
	{
	  A.printnum(M_Coco_1,p); // sent to user %s
	  AffTagScore(N_CocoThrow,0);
	}
      break;
    case 'R':
      if ( a.ki == Moi->numdeuser ) 
        A.printnumln(M_Coco_2); // Coco loves you
      else
	{
	  A.printnum(M_Coco_3,p); // received from user %s
	  AffTagScore(N_CocoLoose,1);
	  printf("Coco message: %s\n",W.St(C_CocoTexte));
	  if (Moi->D->Set(N_cflag, U_bip)) A.beep();   
	}
      break;
    case 'F':
      A.printnumln(M_Coco_4); // comming on your shoulder
      break;
    case 'L':
      A.printnumln(M_Coco_5,p); // stollen by user %s
      AffTagScore(N_CocoLoose,1);
      break;
    case 'E':
      A.printnum(M_Coco_6,p); // %s not enough idle
      AffTagScore(N_CocoError,1);
      break;
    case 'e':
      A.printnumln(M_Coco_7); // not a player
      break;
    default: Debug(1,"Tag::protocole(), pas compris\n");
    }
  /*
    
    A.printf2("CocoHere",W.name(ki),W.mem->DAT[N_CocoLoose]);
    AffTagScore(-W.mem->DAT[N_CocoLoose]);*/
}

void Print_Ack(const Un_Ack & a)
{
  if ( a.type == 'L' ) M.no_print=1; else
    A.printnum(a.received?M_MessageRead:M_LoogedBRM,
	       W.name(a.ki),a.type);
}

void Deal_Hello_Baille(const Hello_Baille & c, char * paol)
{
  if ( c.hello )
    Say_Hello(paol);
  else
    yabon=0;
}

void Aff_Liste( const RListe & a)
{
  A.ln();
  
  AR(M_Liste_R1,a.Z);
  AR(M_Liste_R2,a.K);
  AR(M_Liste_R3,a.L);
  AR(M_Liste_R4,a.E);
  AR(M_Liste_R5,a.N);
}

void Catch_Modif(void)
{
  modifie = 1;
  A.printnumln(M_ReReadInfos);
}

int main(int argc, char ** argv)
{

  if (argc!=3) 
    {
      fprintf(stderr,"Syntax: %s Username from\n",argv[0]); return 1;
    }
       
  try
    {

      Moi = new C_User_C(argv[1]);
      
      ZeRoom = new C_room(65535,0,0);
      
      A.Reset(Moi->D->Num(N_langue),Moi->D->Num(N_cflag),Moi->D->Num(N_more));
      A.Efface();
 
      do 
	{
	  try
	    {
	      int nbpret;
	      A.FreeMsg();
	      A.Blank();
	      
	      Moi->ResetSelect();
	      
	      if ( ! M.encours() ) Moi->AddSelect(Moi->f_r);
	      if ( yabon != 2 )    Moi->AddSelect(0); // stdin
	  
	      if ( M.no_print == 1 ) 
		M.no_print = 0; // on fait pas le big_print
	      else
		{
		  if ( M.encours() ) M.printline(); else 
		    ZeRoom->PrintLine();
		}
	      
	      if (modifie) Deal_Modif();
	      nbpret = Moi->Select(0);
	      

	      if (nbpret<=0) { A.printf2("CaChie"); yabon=0; }
	  
	      if(Moi->IsSelect(0)) // stdin
		{
		  W.IDLE();		  
		  M.GereKey(); 
		  W.IDLE();
		}
	      
	      if(Moi->IsSelect(Moi->f_r))
		{
		  unsigned char ch;
		  if ( ! Moi->InitRead() ) 
		    {
		      M.no_print=1;
		      continue;
		    }  
		  Moi->Lit(ch);
		  switch (ch)
		    {
		    case 'X': 
		      {
			Un_X a;
			Moi->Get_X(a);
			Print_X(a);
		      }
		      break;
		    case ' ': 
		      {
			Un_Post a;
			Moi->Get_Post(a); 
			ChangeRoom(a.room); 
			ZeRoom->PrintPost(a);
		      }
		      break;
		    case 'N': 
		      {
			Moi->Lit_Sauve(k_Read); 
			Catch_Modif();
		      }
		      break;
		    case 'a': case 'A':
		      {
			Un_Ack a;
			Moi->Get_Ack(ch =='a',a); 
			Print_Ack(a);
		      }
		      break;
		    case 'R': 
		      {
			Un_Roume a;
			Moi->Get_Room(a); 
			ChangeRoom(a); 
		      }
		      break;
		    case 'S': case 'K':
		      {
			Hello_Baille a(ch =='S');
			Deal_Hello_Baille(a,argv[2]);
		      }
		      break;
		    case 'h': case 'b':
		      {
			Un_log a;
			Moi->Get_Log(ch =='h',a); 
			Print_Log(a);
		      }
		      break;	     
		    case 'k': 
		      {
			RListe a;
			Moi->Get_RListe(a); 
			Aff_Liste(a);
		      }
		      break;
		    case 'T': 
		      {
			Un_Tag a;
			Moi->Get_Tag(a); 
			Print_Tag(a);			  
		      }
		      break;
		    case 'M':
		      {
			Un_Medor a;
			Moi->Get_Medor(a);
			Print_Medor(a);
		      }
		    default:
		      printf("C_User_C::Gere: error protocole: %c(%d)\n",ch,ch);
		    } // end swithc ch
		  //Moi->Gere(); 
		}// end fd_isset	 
	    } // end du try
	  catch ( ... )
	    {
	      printf("BUG ? .......... Euh, in case of, I shut the client\n");
	      printf("If it should not have done that, please post this in BUG\n");
	      yabon = 0;
	    }
	} // end do
      while(yabon);
    
      Moi->D->SetNum(N_logout,time(0));
      Moi->D->Inc(N_tpspasse,time(0)-Moi->D->Num(N_lastlog));
      Moi->Lit_Sauve(k_Write);
  
      A.printf2("bye");
      /*      if ( Moi->PlayCoco() && 
	   (W.mem->DAT[N_CocoRoom] > 10) && ( W.HaveTAG() == Moi->numdeuser ) )
	{
	  Moi->Poste(W.mem->DAT[N_CocoRoom],
		     W.St(C_CocoSubject),
		     W.St(C_CocoAlias),
		     W.St(C_CocoPost));
		     }*/
      delete Moi;
      delete ZeRoom;
  
      system("/usr/games/fortune");
  
      return 0; 
  
    }
  catch (MemProbs e)
    {
      fprintf(stderr,E_MemProbs); 
    }
  catch ( ErreurLecture   )
    {
      fprintf(stderr,"Problem reading data from server!\n");
    }
  catch ( PlusPersonne )
    {
      fprintf(stderr,E_PlusPersonne);
    }
  catch ( BadUser )
    {
      fprintf(stderr,E_BadUser);
    }
  catch (  NoClav ) 
    {
      fprintf(stderr,E_NoClav);
    }
  catch (...)
    {
      fprintf(stderr,E_Autre);
    }
  fprintf(stderr,EXITING);
  sleep (3);
  return 1;
}

void terminate(void)
{
  fprintf(stderr,E_Autre);
  exit(0);
}



