/* ***************************************************************** *
 * Send Mail                                                         *
 * ================================================================= *
 * Creation date . . . . . . . . . . . . . . . . . . Sat 16 Jan 1999 *
 * Modification date . . . . . . . . . . . . . . . . Sun 17 Jan 1999 *
 * ================================================================= *
 * Copyright (C) 1997-1998 Free Software Foundation, Inc.            *
 *                                                                   *
 * This program  is  free software;  you can  redistribute it and/or *
 * modify it  under the terms  of the GNU  General Public License as *
 * published by  the Free Software Foundation;  either version 2, or *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program  is distributed in the hope  that it will be useful, *
 * but WITHOUT  ANY WARRANTY;  without even  the implied warranty of *
 * MERCHANTABILITY  or  FITNESS  FOR A  PARTICULAR PURPOSE.  See the *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along  with  this  program;  if not,  write to  the Free Software *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         *
 *                                                                   *
 * ================================================================= *
 * Authors                                                           *
 *   Sebastien APERGHIS-TRAMONI <saper@esil.univ-mrs.fr>             *
 *                                                                   *
 * If you find any bug, or if you do any improvment, please send us  *
 * a mail (possibly with diff and/or correction).                    *
 *                                                                   *
 * ***************************************************************** */


#ifndef BBS_MAIL
#define BBS_MAIL


/* ***************************************************************** *
 * classes                                                           *
 * ***************************************************************** */
class Mail {
    char *  _server;
    char *  _sender;
    char *  _recipient;
    char *  _subject;
    char *  _message;
    
  public:
    // Constructor and destructor
    Mail    (char * sender = NULL,  char * recipient = NULL, 
             char * subject = NULL, char * message = NULL  );
    ~Mail   (void);
    
    // Access methods
    void    Server      (char * server);
    void    Sender      (char * sender);
    void    Recipient   (char * recipient);
    void    Subject     (char * subject);
    void    Message     (char * message);
    
    // Execution
    void    Send        (void);
    
  private:
    int     Connect     (char * server, int port);
};

// Exceptions
class Mail_BadPortNumber     {};  // The given port is not a valid port.
class Mail_MalformedAddress  {};  // The address is malformed (no '@' was found). 
class Mail_NoMessage         {};  // No message was given.
class Mail_NoRecipient       {};  // No Recipient was given.
class Mail_ServerUnknown     {};  // The DNS request to get the server's IP failed.
class Mail_ServerUnreachable {};  // The connection to the server failed.


#endif /* BBS_MAIL */

