/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "Post_N.H"
#include "G_B_R_Pipe.H"
#include "S_Users.H"
#include "S_wholist.H"

extern S_wholist W;
extern G_B_R_Pipe p;
extern S_Users U;

Post_N::Post_N()
  :Post()
{
  NB_KI   = 1;
  MULTIPLE = 0;
  KI      = new unsigned short[1];
  KI_Etat = new unsigned char[1];
  POS     = new unsigned short[1];
  TYPE_ROOM = 'N';
}

void Post_N::Lit(S_Load *a)
{
  LIT(a);
  NB_KI = 1;
  a->Lit(subject); 
  a->Lit(AliasName);
  a->Lit(KI,sizeof(short));
  a->Lit(POS,sizeof(short));
}

void Post_N::Sauve(S_Save * a)
{
  SAUVE(a);
  a->Envoie(subject);
  a->Envoie(AliasName);
  a->Envoie(KI,sizeof(short));
  a->Envoie(POS,sizeof(short));
}

void Post_N::Recoit(unsigned short nom)
{
  RECOIT(nom);
  KI[0]=nom;
  p.Lit(subject);
  p.Lit(AliasName);
}

void Post_N::Envoie(unsigned short ki)
{ 
  U.Envoie(POS[0]);
  ENVOIE(ki);
  
  U.Envoie(KI[0]);
  U.Envoie(AliasName);
  U.Envoie(subject);
  U.flush();
}

Post_N::~Post_N()
{
}

Post * Post_N::CopyPost(void)
{
   Post_N * temp = new Post_N();
   UpdatePost( * temp);
   temp->subject   = subject;
   temp->AliasName = AliasName;
   return temp;
}


const char * Post_N::username()
{
  if ( ! AliasName.null() )
    return AliasName.data();
  
  return W.name(KI[0]);
}
