/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */


#include <string.h>
#include <strings.h>
#include "S_G_room.H"
#include "MAX.H"
#include "Post_M.H"
#include "Post_N.H"
#include "Post_L.H"
#include "S_wholist.H"
#include "G_Path.H"
#include "ROOM.H"
#include "ROOM_ENUM.H"
#include "consts.H"
#include "S_Hash_R.H"
#include "Debug.H"


extern G_Path G;
extern S_wholist W;
extern S_Hash_R H_R;

// Generic room


S_G_room::S_G_room(unsigned short num)
  :NumDeRoom(num),NbDePosts(0), NbPasSav(0),ici(0),PREMS(0)
{
  D = new Dat(U_Cle,tailles,MAX_CH, MAX_L);
  D->L(L_Pos)->doublons=1; // Yes, on doublonne tout ca :)
  ici = & ( W.mem->Rooms[NumDeRoom] );
}

void S_G_room::Efface(Post ** ZePost, int recursif)
{
  if (!*ZePost) return;
  if (recursif) Efface(&((*ZePost)->SUIV),recursif);
  delete *ZePost;
  *ZePost=0;
}

int S_G_room::Traite_Posts(char * nom,TypeLecture LeType )
{
  Post ** Encours=& PREMS;
  Post * Enc = PREMS;
  int i;
  if ( LeType == k_Read )
    {
      S_Load l(nom);
      if ( l.f == -1 ) return 0;
      l.Lit(NbDePosts);
      Debug(1,"Reading %d posts\n",NbDePosts);
      for (i=0; i< NbDePosts; i++ )
	{
	  Post * Temp_Post;
	  unsigned char ch;
	  l.Lit(ch);
	  switch ( ch )
	    {
	    case 'L': Temp_Post = new Post_L(); break;
	    case 'M': Temp_Post = new Post_M(); break;
	    case 'N': Temp_Post = new Post_N(); break;
	    default: Debug(3,"protocol ERROR ! do not understand %c type of post!!!\n",ch);
	    }
	  Temp_Post -> Lit(&l);
	  * Encours = Temp_Post;
	  Encours = & ( (*Encours) -> SUIV );
	}
      CheckPostEnCours();
    }
  else
    {
      S_Save s(nom);
      if ( s.f == -1 ) return 0;
      s.Envoie(NbDePosts);
      Debug(1,"Writing %d posts\n",NbDePosts);
      for (i=0; i< NbDePosts; i++ )
	{
	  Enc->Sauve(&s);
	  Enc = Enc->SUIV;
	}
    }
  return 1;
}

void S_G_room::Deleter(unsigned short i, unsigned short nom)
{
  Debug(0,"S_G_Room::Deleter(room=%d,post=%d,user=%d)\n",NumDeRoom,i,nom);
  Post * EnCours=PREMS;
  Post * Ancien=0;
  if ( ! EnCours ) return;

  while ( EnCours && EnCours->GetNum(nom) < i ) 
    {
      Debug(0,"( %d ) ",EnCours->GetNum(nom));
      Ancien  = EnCours;
      EnCours = EnCours->SUIV;
    }
  Debug(0,"\n");
  if ( ! EnCours ) return;
  if ( EnCours->GetNum(nom) !=i ) return;
  EnCours -> Del(nom);
  if ( ! EnCours->CanDel() ) return;
  Post * Suivant = EnCours->SUIV;
  
  if ( ! Ancien  ) // Del of first post
    {
      Efface(&PREMS,0);
      PREMS = Suivant; 
    }
  else 
    {
      Efface(&EnCours,0);
      Ancien->SUIV=Suivant; 
    }
  NbDePosts --; // IMPORTANT !!!!!!!!!!!!!!
  //  CHECK FOR CURRENT POST !!!
  CheckPos();
}

Post * S_G_room::GetNext(unsigned short ki)
{
  return GetPost(ki,GetPos(ki)+1,1);  
}
 
Post * S_G_room::GetPost(unsigned short ki,unsigned short begin,int update)
{
  if ( (State(ki) != 'N') && (State(ki) != 'F') ) return 0;
  unsigned short pos = begin; // Ze pos de la personne
  Debug(0,"S_G_room::GetPost(R=%d,U=%d,P=%d,num=",NumDeRoom,ki,pos);
  Post * Encours=PREMS;
  Post * Ancien=0;

  while ( Encours && Encours->GetNum(ki) < pos ) 
    {
      Ancien = Encours;
      Encours = Encours->SUIV;
    }

  if ( Encours && Encours->GetNum(ki) > GetLast(ki) )
    {
      Debug(3,"ERROR:S_G_room::GetPost: pos > last !!!\n");
      Debug(3,"DELETING THE FAULTY POST !!!\n");
      Post * Suivant = Encours->SUIV;
      if ( ! Ancien  ) // Del of first post
	{
	  Efface(&PREMS,0);
	  PREMS = Suivant; 
	}
      else 
	{
	  Efface(&Encours,0);
	  Ancien->SUIV=Suivant; 
	}
      NbDePosts --; // IMPORTANT !!!!!!!!!!!!!!
      //  CHECK FOR CURRENT POST !!!
      CheckPos();
      return GetPost(ki,begin,update);
    }
  if (Encours && Encours->IsMine(ki) ) 
    {
      int pos = Encours->GetNum(ki);
      Debug(0,"%d)\n",pos); 
      if ( update ) SetPos(ki,pos); // On update la pos 
      Encours->MarkRead(ki);
      return Encours;
    }
  else Debug(0,"=finished)\n");
  
  return 0;
}

void S_G_room::Poster(Post * ZePost)
{
#warning "Faire les tests a la con pour roume invited ... "
  while (NbDePosts > MAXP() ) 
    {
      Debug(0,"@ MAX=%d REACHED => DEL FIRST(%d)\n",MAXP(),NumDeRoom);
      Post * Sav = PREMS->SUIV;
      Efface(&PREMS, 0);
      PREMS=Sav;
      NbDePosts --;
    }

  Post ** EnCours = & PREMS;
  while (*EnCours) EnCours=&(*EnCours)->SUIV;

  for ( int i=0; i< ZePost -> NB_KI; i++ )
    {
      unsigned short u = ZePost->KI[i];
      unsigned short l = GetLast(u) +1;
      ZePost->POS[i] = l;
    }

  * EnCours=ZePost;
  NbDePosts++;

  Debug(0,"@ NbDePosts=%d\n",NumDeRoom);
  int nombre = 1;
  if ( NumDeRoom == 0 ) nombre = 40; // on soulage poooov disque dur
  if ( ++ NbPasSav >= nombre ) 
    {
      NbPasSav = 0;
      Lit_Sauve(k_Write);
    }
  CheckPostEnCours();
}

void S_G_room::CheckPostEnCours(void)
{
  ResetLast();
  Post * Encours = PREMS;
  while (Encours)
    {
      for ( int i = 0; i < Encours -> NB_KI; i++)
	SetLast( Encours->KI[i], Encours->POS[i]);
      Encours=Encours->SUIV;
    }
}

char S_G_room::State(unsigned short nom)
  // Est ce ke le user "nom" peut aller dans cette room
  /* State returns possibilities:
   *: no such user logged in, or the room is not valid, or room Yell
   P: room invisible or with rights, and not invited
   Z: room zapped
   K: kicked of the room
   F: the user has read all the posts of the room
   N: normal case (reading the posts, and allowed to do so)
  */
{
  unsigned short pos  = GetPos(nom);
  unsigned short last = GetLast(nom);
  USRINFO * poil = W.User(nom);
  if ( ! poil ) return '*'; 
  if ( ! valid() ) return '*';
  if ( NumDeRoom == ROOM_YELL ) // roume YELL, should just be read by Admins 
    {
      if ( !( poil->u_rights & D_admin ) ) return '*';
    }
  // invisible rooms
  if ( 
      (ici -> flags & R_invisi) && ! 
      ( 
       W.IsInvited(nom,NumDeRoom ) || 
       W.IsRA(nom,NumDeRoom) || 
       ( (poil->u_rights & D_admin) && (NumDeRoom < 10) )
       )
      )
    {
      return 'P';
    }
  unsigned long d = D->Num( N_Droits_N );
  if ( d  ) // This is an island with rights associated
    {
      if ( ! (poil->u_rights & d) ) return 'P'; // he has not the good rights
    }
  if ( pos == 65535 ) return 'Z'; // Zappee
  if ( pos == 65534 ) return 'K'; // Kicke
  if ( pos == last ) return 'F'; // Room toute lue ...
  if ( pos > last && pos < 65534 )
    {
      Debug(2,"ERROR: S_G_room::State(U=%d,R=%s(%d),P=%d, ====---\n",
	     nom,Name(),NumDeRoom,pos);
      SetPos(nom,last);
      return 'F'; // on dit k'il a lu toute la room ...
    }
  return 'N'; // Rien a declarer ...
}

unsigned short S_G_room::MAXP(void) 
{ return D->Num(N_MaxP_N); }


void S_G_room::Reload(void) 
{
  Debug(1,"RELOAD(%d)\n",NumDeRoom);
 
  GereInfos(k_Read);
}

void S_G_room::GereInfos(TypeLecture LeType)
{
  Debug(1,"S_G_room::GereInfos(%d)\n",NumDeRoom);
  if ( LeType == k_Write ) CheckPos();
  char * tp;
  tp = G.GetRoomFile("Infos",NumDeRoom);
  {
    try
      {
        FileInfo FF (tp,LeType,D );
        FF.Proceed();

        if ( LeType == k_Read && D->L(L_Pos)->size()<MAX_USERS )
          {
            fflush(stdout);
            while ( D->L(L_Pos)->size()<MAX_USERS )
               D->L(L_Pos)->Ajoute(0); 
          }
      }
    catch ( FileProbs )
      {
        Debug(2,"ERROR: IO %s\n",tp);
      }
  }

  if ( LeType == k_Read ) //update mem partagee
    {
      H_R.remove(NumDeRoom);
      if ( valid() )
	{  
	  H_R.insert(Name(),NumDeRoom);
	  
	  ici->flags     = D->Num(N_flags_N);
	  ici->comprises = D->Num(N_langues_N);
	  /*    ici->last      = D->Num(N_Modified_N);
		ici->login     = D->Num(N_Created_N);*/
	  LISTE a(MAX_INVITED,ici->INVITED,&(ici->NB_Invited));
	  a.MetNull(); a.Ajoute(* D->L(L_I));
	  LISTE b(MAX_RA,     ici->RA,     &(ici->NB_Ra));
	  b.MetNull(); b.Ajoute(* D->L(L_RA));
	} 
      else 
	{
	  Debug(0,"Invalid room %d\n",NumDeRoom);
	  //W.mem->RoomName[NumDeRoom][0]=0; // mastre de vdb que je suis
	}
    }
}

int S_G_room::Lit_Sauve(TypeLecture LeType)
{
  Debug(1,"S_G_room::Lit_Sauve(R=%d): ",NumDeRoom);
  fflush(stdout);
  GereInfos(LeType);
  if ( ! Traite_Posts(G.GetRoomFile("Posts",NumDeRoom),LeType ) )  return 0;
  if ( LeType == k_Read ) CheckPos();
  return 1;
}
 
const char * S_G_room::Name(void)
{
  return D->St(C_Nom).data();
}

int S_G_room::valid(void)
{
  return ((int)Name() && MAXP() );
}


void S_G_room::SetPos(unsigned short nom, unsigned short nvellepos)
{
  D->L(L_Pos)->DATA[nom]=nvellepos;
}

unsigned short S_G_room::GetPos(unsigned short nom)
{ return D->L(L_Pos)->DATA[nom]; }



void S_G_room::CheckPos(void)
{
  LISTE * LL = D->L(L_Pos);
  CheckPostEnCours();
  unsigned short pos;
  for (int i=0; i< MAX_USERS; i++) 
    if ( ( pos = LL->DATA[i] ) > GetLast(i) && pos < 65534 )
      {
	Debug(0,"S_G_room::CheckPos(U=%d,R=%d,P=%d)\n",
	       i,NumDeRoom,pos);
	LL->DATA[i]=GetLast(i);
      }
}

