/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: 
      Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "S_Hash_U.H"
#include "S_wholist.H"
#include "G_Path.H"
#include "Debug.H"
#include <stdio.h>
#include <string.h>

static const char * users = "users/";
static const char * liste = "liste";

extern G_Path G;
extern S_wholist W;

S_Hash_U::S_Hash_U( void )
  :S_Hash(W.mem)
{
  int i;
 
  Debug(0,"S_Hash_U::S_Hash_U()\n");
  
  nb() =0;
  for(i=0; i<255; i++ )       index(i)=0;
  for(i=0; i<MAX_USERS; i++ ) table(i)=0;
  load();
}

void S_Hash_U::load(void)
{
  FILE * f;
  char buffer[100+1];
  int id=0;
  
  Debug(2,"S_Hash_U::load()\n");
  sprintf(buffer,"%s%s",users,liste);

  char * tp = G.GetEtcHome(buffer);
  if (!(f=fopen(tp,"r"))) 
    { printf("NO USER FILE !!!!!!\n"); return ; }
  delete [] tp;

  while ( fgets(buffer,sizeof(buffer),f) )
  {
    buffer[strlen(buffer)-1]=0;
    buffer[LG_NOM_USER]=0; // Palier aux merdes de tilde ...
    if (buffer[0]) 
    {
      printf("(%d): %s\n",id,buffer);
      insert(buffer,id);
    }
    id ++;
  } 
  fclose(f);
  printf("TOTAL users/MAX: %d/%d\n",m->n_user,MAX_USERS);
}

char * S_Hash_U::Str(unsigned short i) const
{
  return m->UserName[i];
}

unsigned short & S_Hash_U::table(unsigned short i) const
{
  return m->t_user[i];
}

unsigned short & S_Hash_U::index(unsigned char A) const
{
  return m->i_user[A];
}

unsigned short & S_Hash_U::nb(void) const
{
  return m->n_user;
}
 


/*void S_Hash_U::remove( char *nom )
{
  int first = nom[0]-'A';
  int i = _Hash->index[first];
  for(; i<_Hash->_nb_users; i++)
    if( strcmp( nom, _Hash->table[i].nom)<=0 )
      break;
  
  if(strcmp( nom, _Hash->table[i].nom) == 0 ){
    //on l'a trouve, on tasse la table
    for(int j = i; j < _Hash->_nb_users; j++)
      _Hash->table[i]=_Hash->table[i+1];
    
    _Hash->_nb_users--;
    
    //on mets a jour la table d'index
    for( i = first + 1; i < 26; i++)
      (_Hash->index[i])--;
  }
  }*/



