/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "S_Users.H"
#include "S_wholist.H"

// Les 2: pour kill
#include <signal.h>
#include <sys/types.h>
// Pour le fait que je gere les listes
#include "LISTE.H"

#include "Debug.H"

extern S_wholist W;
extern void BougeWholist(unsigned short source, unsigned short destination);

S_Users::S_Users(void)
  :user(-1)
{
  int n;
  for ( n=0; n < MaxWholistTaille; n++ )
    LE[n]=0;
}

S_Users::~S_Users()
{

}

int S_Users::Set(unsigned short num)
{
  return ((user=Cherche(num)) != -1);
}

int S_Users::Set(unsigned short deki, unsigned short pourki, unsigned char type)
  // Set le user si posssible, et previent deki si pas possible
{
  if ( ! Set(pourki) )
    {
      if ( Set(deki) )
	{
	  try 
	    {
	      Envoie((unsigned char)'A'); // previent ke plus la ...
	      Envoie(pourki);
	      Envoie(type);
	      flush();
	    }
	  catch ( SendPipeProbs  )
	    {
	      Debug(3,"ERREUR: S_Users::Set(), wired ?\n");
	      Del_Encours();
	    }
	}
      return 0;
    }
  return 1;
}

int S_Users::AddRequest(unsigned short ki)
{
  if ( ! Set (ki) ) return 0;
  return LE[user]->AddRequest();
}

void S_Users::Del(unsigned short ki)
{
  unsigned short i;
 
  if ( ! Set (ki) ) return;
  Debug(1,"DelUser(%d)\n",ki);
 
  W.mem->Infos[W.mem->place[user]].OQP=0;
 
  S_user * temp = LE[user];
  LE[user]=0;
 
  for (i=user;i<W.mem->nbpers-1;i++)  // On refait la Wholist
    BougeWholist(i+1,i);
 
  W.mem->nbpers --;
 
  for (i=0;i<W.mem->nbpers;i++)
  {
    user = i; // pour ke recursif ca tienne ! 
    try 
      {
	Debug(0,"%d: bye to %d\n",ki,GetNum());
	Envoie((unsigned char)'b');
	Envoie(ki);
	flush();
      }
    catch ( SendPipeProbs )
      {
	Debug(3,"Oups, recursive deletion ( Deleting user while deleting another one )!!!\n");
	Del_Encours();
      }
  }
  // On retire le user de toutes les listes !!!
  for ( int k=0; k< MAX_LISTE;k++)
    {
      LISTEINFO * muche = & (W.mem->Listes[k]); 
      LISTE poal(MAX_ABONES_LISTE,muche->Abone,&(muche->NB_Abones));
      poal.Enleve(ki);
    }
  // A FAIRE A LA FIN !!!!
  user = -1;
  delete temp;
}

void S_Users::Insert(unsigned short ki, pid_t PID)
{
  unsigned short nom=W.mem->nbpers;  
  LE[nom] = new S_user(ki,PID);  
}

void S_Users::Del_Encours(void)
{
  Del(GetNum());
}
  
void S_Users::Envoie(const void * koa, unsigned int taille)
{
  if ( test() )
    LE[user]->Envoie(koa, taille);
}

void S_Users::flush(void)
{
  if ( test() )
    LE[user]->flush();
}
  
void S_Users::Envoie(unsigned short i)
{
  if ( test() )
    LE[user]->Envoie(i);
}

void S_Users::Envoie(unsigned char i)
{
  if ( test() )
    LE[user]->Envoie(i);
}

void S_Users::Envoie(const String & i)
{
  if ( test() )
    LE[user]->Envoie(i);
}

void S_Users::EnvoieG(const char *  i )
{
  if ( test() )
    LE[user]->EnvoieG(i);
}

void S_Users::EnvoieD(char * & i )
{
  if ( test() )
    LE[user]->EnvoieD(i);
}

void S_Users::EnvoieMsg(unsigned char i)
{
  if ( test() )
    LE[user]->EnvoieMsg(i);
}
 

void S_Users::SendSX(unsigned short a,unsigned short b)
{
  if ( test() )
    LE[user]->SendSX(a,b);

}

void S_Users::SendX(unsigned short a, char type, const char * b, unsigned short right)
{
  if ( test() )
    {
      try 
	{
	  LE[user]->SendX(a,type,b,right);
	  if (type=='K')
	    {
	      send_signal(SIGTERM);
	      Del_Encours();
	    }
	}
      catch ( SendPipeProbs )
	{
#warning "ca devrait faire lieu a un envoi de msg"
	  Debug(3,"ERREUR: Le message n'a pas pu etre envoye !!!\n");
	  Del_Encours();
	}
    }
}

int S_Users::test(void)
{
  return ( user >= 0 && user < MaxWholistTaille -1 && LE[user] );
}

int S_Users::Cherche(unsigned short num)
{
  int i;
  for (i=0;i<W.mem->nbpers;i++) if (LE[i]->num==num) return i; 
  return -1;
}

void S_Users::send_signal(int sgn)
{
  if ( ! test() ) return;
  kill(LE[user]->pid,sgn);
  Debug(2,"kill Num = %d, PID=%d\n", GetNum() , LE[user]->pid);
}

unsigned short S_Users::GetNum(void)
{
  if ( test() ) return LE[user]->num; else return 65535;
}

void S_Users::HelloAll(unsigned short ki)
{
  for (int i=0;i<W.mem->nbpers;i++) // previent k'il s'est loge
    {
      user = i;  // pour ke recursif ca tienne !
      if ( GetNum() != ki )
	{
	  try 
	    {
	      Envoie((unsigned char)'h');
	      Envoie(ki);
	      flush();
	    }
	  catch ( SendPipeProbs )
	    {
	      Del_Encours();
	    }
	}
    }
}

void S_Users::KickAll(unsigned short nom, char * MSG)
{
  for (user=0;user<W.mem->nbpers;user++)
  {
    SendX(nom,'k',MSG,0);
  }
}

