#include "ClientComm.H"

Struct_Message::Struct_Message (void)
        {
	mesg = NULL;
	}

Struct_Message::~Struct_Message (void)
        {
	destroy_message ();
	}

struct Struct_Message::message *Struct_Message::message_malloc (void)
        {
	return (struct message *) malloc (sizeof (struct message));
	}

struct Struct_Message::maillon_message_field *Struct_Message::field_malloc (void)
        {
	return (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
	}

void Struct_Message::define_message (void)
        {
	destroy_message ();
	mesg = message_malloc ();
	mesg->msgtype = NULL;
	mesg->msgrange = NULL;
	mesg->msgbody = NULL;
	}

int Struct_Message::define_type (char car)
        {
	if (mesg == NULL)
	        {
		return -1;
		}
	mesg->msgtype = (char *) malloc (sizeof (char));
	*(mesg->msgtype) = car;
	return 0;
	}

int Struct_Message::define_range (char car)
        {
	if (mesg == NULL)
	        {
		return -1;
		}
	mesg->msgrange = (char *) malloc (sizeof (char));
	*(mesg->msgrange) = car;
	return 0;
	}

int Struct_Message::define_field (void)
        {
	struct maillon_message_field **current;
	struct maillon_message_field *prec;

	if ((mesg == NULL)
	    || (mesg->msgtype == NULL)
	    || (mesg->msgrange == NULL)
	    )
	        {
		return -1;
		}
	if (mesg->msgbody == NULL)
	        {
		current = &(mesg->msgbody);
		}
	else
	        {
		current = &(mesg->msgbody->next);
		prec = mesg->msgbody;
		while (*current != NULL)
		        {
			current = &((*current)->next);
			prec = prec->next;
			}
		if ((prec->field_name == NULL) || (prec->field_value == NULL))
		        {
			return -1;
			}
		}
	*current = field_malloc ();
	(*current)->field_name = NULL;
	(*current)->field_value = NULL;
	(*current)->next = NULL;
	return 0;
	}

int Struct_Message::define_field_name (char *str)
        {
	struct maillon_message_field **current;

	if ((mesg == NULL) || (mesg->msgbody == NULL))
	        {
		return -1;
		}

	current = &(mesg->msgbody);
	while ((*current)->next != NULL)
	        {
		current = &((*current)->next);
		}

	(*current)->field_name = (char *) malloc ((strlen (str) + 1) * sizeof (char));
	strcpy ((*current)->field_name, str);
	return 0;
	}

int Struct_Message::define_field_value (char *str)
        {
	struct maillon_message_field **current;

	if ((mesg == NULL) || (mesg->msgbody == NULL))
	        {
		return -1;
		}

	current = &(mesg->msgbody);
	while ((*current)->next != NULL)
	        {
		current = &((*current)->next);
		}

	(*current)->field_value = (char *) malloc ((strlen (str) + 1) * sizeof (char));
	strcpy ((*current)->field_value, str);
	return 0;
	}

void Struct_Message::new_message (char typ, char ran)
        {
	define_message ();
	if (define_type (typ) < 0)
	        {
		perror ("Bug report : cannot define type for a message\n");
		exit (-1);
		}
	if (define_range (ran) < 0)
	        {
		perror ("Bug report : cannot define range for a message\n");
		exit (-1);
		}
	}

int Struct_Message::add_field (char *nam, char *val)
        {
	if (define_field () < 0)
	        {
		return -1;
		}
	if (define_field_name (nam) < 0)
	        {
		perror ("Bug report : cannot define name for a message field\n");
		exit (-1);
		}
	if (define_field_value (val) < 0)
	        {
		perror ("Bug report : cannot define value for a message field\n");
		exit (-1);
		}
	return 0;	
	}

int Struct_Message::add_field (char *nam, char val)
        {
	char *valstr;
	int res;

	valstr = (char *) malloc (2 * sizeof (char));
	valstr [0] = val;
	valstr [1] = '\0';
	res = add_field (nam, valstr);
	free (valstr);
	return res;
	}

int Struct_Message::us_size (unsigned short val)
        {
	int i = 1;

	while (val > 9)
	        {
		val = (unsigned short) val / 10;
		i++;
		}
	return i;
	}

void Struct_Message::us_to_a (char *nam, unsigned short val)
        {
	int size;
	int i = 1;

	size = us_size (val);
	nam = (char *) malloc ((size + 1) * sizeof (char));
	while (val > 9)
	        {
		nam [size - i] = (char) (val % 10) + '0';
		val = (unsigned short) val / 10;
		i++;
		}
	nam [i] = '\0';
	}

int Struct_Message::add_field (char *nam, unsigned short val)
        {
	char *valstr;
	int res;

	us_to_a (valstr, val);
	res = add_field (nam, valstr);
	free (valstr);
	return res;
	}

char *Struct_Message::get_type (void)
        {
	if (mesg == NULL)
	        {
		return (char *) NULL;
		}
	else
	        {
		return mesg->msgtype;
		}
	}

char *Struct_Message::get_range (void)
        {
	if (mesg == NULL)
	        {
		return (char *) NULL;
		}
	else
	        {
		return mesg->msgrange;
		}
	}

char *Struct_Message::get_field_value (char *nam)
        {
	struct maillon_message_field *current;

	if ((mesg == NULL) || (mesg->msgbody == NULL))
	        {
		return (char *) NULL;
		}

	current = mesg->msgbody;
	while ((current == NULL) || (strcmp (current->field_name, nam)))
	        {
		current = current->next;
		}

	if (current == NULL)
	        {
		return (char *) NULL;
		}
	else
	        {
		return current->field_value;
		}
	}

Struct_Buffer::Struct_Buffer (void)
        {
	buff = NULL;
	last = NULL;
	}

Struct_Buffer::~Struct_Buffer (void)
        {
	destroy_buffer ();
	}

Message::Message (void)
        {
	mesg = NULL;
	buff = NULL;
	last = NULL;
	}

Message::~Message (void)
        {
	destroy_message ();
	destroy_buffer ();
	}

void Struct_Message::afficher_msgbody (struct maillon_message_field *mai)
        {
	if (mai == NULL)
	        return;
	if ((mai->field_name == NULL) || (mai->field_value == NULL))
                return;
	printf ("\t%s = \"%s\"\n", mai->field_name, mai->field_value);
	afficher_msgbody (mai->next);
	}

void Struct_Message::afficher_message (void)
        {
	if (mesg == NULL)
	        return;
	if ((mesg->msgtype == NULL) || (mesg->msgrange == NULL))
                return;
	printf ("Message :\n%c (%c)\n", *(mesg->msgtype), *(mesg->msgrange));
	if (mesg->msgbody == NULL)
	        return;
	printf ("\t{\n");
	afficher_msgbody (mesg->msgbody);
	printf ("\t}\n\n");
	}

void Struct_Buffer::afficher_buffer (void)
        {
	struct maillon_buffer *maillon;

	maillon = buff;

	if (buff == NULL)
	        return;
	printf ("Buffer :\n");
	do
	        {
		printf ("%c", maillon->car);
		}
	while (maillon->next != NULL);
	printf ("\n");
	}

void Struct_Message::destroy_msgtype (char **msgtype)
        {
	if (*msgtype != NULL)
	        {
	      	free (*msgtype);
		*msgtype = NULL;
		}
	}

void Struct_Message::destroy_msgrange (char **msgrange)
        {
	if (*msgrange != NULL)
	        {
	      	free (*msgrange);
		*msgrange = NULL;
		}
	}

void Struct_Message::destroy_string (char **maillon)
        {
	if (*maillon != NULL)
	        {
		free (*maillon);
		*maillon = NULL;
		}
	}

void Struct_Message::destroy_maillon (struct maillon_message_field **maillon)
        {
	if (*maillon != NULL)
	        {
		destroy_string (&((*maillon)->field_name));
		destroy_string (&((*maillon)->field_value));
		free ((*maillon)->next);
		*maillon = NULL;
		}
	}

void Struct_Message::destroy_msgbody (struct maillon_message_field **msgbody)
        {
	if (*msgbody != NULL)
	        {
		destroy_msgbody (&((*msgbody)->next));
		destroy_maillon (msgbody);
		*msgbody = NULL;
		}
	}
	
void Struct_Message::destroy_message (void)
        {
	if (mesg != NULL)
	        {
		destroy_msgtype (&(mesg->msgtype));
		destroy_msgrange (&(mesg->msgrange));
		destroy_msgbody (&(mesg->msgbody));
		free (mesg);
		mesg = NULL;
		}
	}

void Struct_Buffer::destroy_buffer (void)
        {
	struct maillon_buffer *maillon;
	struct maillon_buffer *temp;

	maillon = buff;
	if (buff != NULL)
	        {
		while (maillon != NULL)
		        {
			temp = maillon;
			maillon = maillon->next;
			free (temp);
			}
		buff = NULL;
		last = NULL;
		}
	}

int Struct_Buffer::read_buffer_from_input (class Socket *sock)
        {
	char carlu;

	destroy_buffer ();
	do
	        {
		if ((*sock).read_char (&carlu) < 0)
		        {
			return -1;
			}
		if (carlu != '\0')
		        {
			add_char_to_buffer (carlu);
			}
		}
	while (carlu != '\0');
	return 0;
	}






int Message::next_token (char *buffer)
        {
	int i = 0;

	while ((buffer [i] == ' ') || (buffer [i] == '\n') || (buffer [i] == '\t'))
		i++;

	return i;
	}

int Message::chars (char c)
        {
	if (((c >= 'a') && (c <= 'z')) || ((c >= 'A') && (c <= 'Z')))
	        return 1;
	return 0;
	}

void Message::new_token (char *buffer, char *ptoken, int *token_length)
        {
	int i = 1;
	int j;
	int cont  = 1;
	int last_was_slash = 0;
	int k = 0;

	if (buffer [0] != '"')
	        {
		if (chars (buffer [0]))
		        {
			while (chars (buffer [i]))
			        i++;
			}

		for (j = 0; j < i; j++)
		        ptoken [j] = buffer [j];
		ptoken [i] = '\0';
		*token_length = i;
		}
	else
	        {
		do
		        {
			if ((buffer [i] == '\\') && (last_was_slash == 0))
				last_was_slash = 1;
			else
			        {
			        if ((buffer [i] == '\0') || ((buffer [i] == '"') && (last_was_slash == 0)))
				        cont = 0;
				last_was_slash = 0;
				}
			i++;
			}
		while (cont);

		for (j = 1; j < (i - 1); j++)
		        {
			if ((buffer [i] == '\\') && (last_was_slash == 0))
				last_was_slash = 1;
			else
			        {
				last_was_slash = 0;
				ptoken [k] = buffer [j];
				k++;
				}
			}
		ptoken [k] = '\0';
		*token_length = i;		
		}
	}

char Message::token_analysis (char *ptoken)
        {
	if (strcmp (ptoken, "S") == 0)
	        return 'S';
	if (strcmp (ptoken, "s") == 0)
	        return 'S';
	if (strcmp (ptoken, "A") == 0)
	        return 'A';
	if (strcmp (ptoken, "a") == 0)
	        return 'A';
	if (strcmp (ptoken, "G") == 0)
	        return 'G';
	if (strcmp (ptoken, "g") == 0)
	        return 'G';
	if (strcmp (ptoken, "{") == 0)
	        return '{';
	if (strcmp (ptoken, "}") == 0)
	        return '}';
	if (strcmp (ptoken, "(") == 0)
	        return '(';
	if (strcmp (ptoken, ")") == 0)
	        return ')';
	if (strcmp (ptoken, "L") == 0)
	        return 'L';
	if (strcmp (ptoken, "l") == 0)
	        return 'L';
	if (strcmp (ptoken, "answer") == 0)
	        return 'a';
	if (strcmp (ptoken, "=") == 0)
	        return '=';
	return 'E';	// Unrecognized token
	}

int Message::analys_msgtype (char *buffer, int *to_next_token_to_read, char **msgtype)
        {
	int avancer;
	int erreur;
	char ptoken [80];
	int token_length;

	erreur = 0;
	avancer = next_token (buffer);

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case 'S':
		        {
			*msgtype = (char *) malloc (sizeof (char));
			**msgtype = 'S';
			}
		break;
		case 'A':
		        {
			*msgtype = (char *) malloc (sizeof (char));
			**msgtype = 'A';
			}
		break;
		case 'G':
		        {
			*msgtype = (char *) malloc (sizeof (char));
			**msgtype = 'G';
			}
		break;
		case 'C':
		        {
			*msgtype = (char *) malloc (sizeof (char));
			**msgtype = 'C';
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));
	*to_next_token_to_read = avancer;

	return erreur;
	}

int Message::analys_msgrange (char *buffer, int *to_next_token_to_read, char **msgrange)
        {
	int avancer;
	int erreur;
	char ptoken [80];
	int token_length;

	erreur = 0;
	avancer = next_token (buffer);

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '(':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case 'L':
		        {
			*msgrange = (char *) malloc (sizeof (char));
			**msgrange = 'L';
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case ')':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));


	*to_next_token_to_read = avancer;

	return erreur;
	}

int Message::analys_msgbody (char *buffer, int *to_next_token_to_read, struct maillon_message_field **msgbody)
        {
	struct maillon_message_field *msgbodycopy;
	int avancer;
	int erreur;
	char ptoken [80];
	int token_length;

	erreur = 0;
	avancer = next_token (buffer);

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '{':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case 'a':
		        {
			*msgbody = (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
			(*msgbody)->field_name = (char *) malloc (7 * sizeof (char));
			(*msgbody)->field_value = NULL;
			(*msgbody)->next = NULL;
		       	strcpy ((*msgbody)->field_name, "answer\0");
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        return -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        return -2;
			}
		}

	msgbodycopy = *msgbody;

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '=':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;
 
	(*msgbody)->field_value = (char *) malloc ((token_length + 1) * sizeof (char));
	strcpy ((*msgbody)->field_value, ptoken);

	avancer += next_token (&(buffer [avancer]));

	while (1)
	{

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '}':
		        {
			avancer += next_token (&(buffer [avancer]));

			*to_next_token_to_read = avancer;
			*msgbody = msgbodycopy;

			return erreur;			
			}
		break;
		case 'a':
		        {
			(*msgbody)->next = (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
			*msgbody = (*msgbody)->next;
			(*msgbody)->field_name = (char *) malloc (7 * sizeof (char));
			(*msgbody)->field_value = NULL;
			(*msgbody)->next = NULL;
		       	strcpy ((*msgbody)->field_name, "answer\0");
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        return -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        return -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '=':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        return -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        return -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	(*msgbody)->field_value = (char *) malloc ((token_length + 1) * sizeof (char));
	strcpy ((*msgbody)->field_value, ptoken);

	avancer += next_token (&(buffer [avancer]));
	}



	*to_next_token_to_read = avancer;
	*msgbody = msgbodycopy;

	return erreur;
	}

int Message::analys_msg (char *buffer)
        {
	int token_length;
	char *msgtype;
	char *msgrange;
	struct maillon_message_field *msgbody;

	msgtype = NULL;
	msgrange = NULL;
	msgbody = NULL;

	if (analys_msgtype (buffer, &token_length, &msgtype) < 0)
	        {
		printf ("Erreur dans la reconnaissance du type de message\n");
		return -1;
		}

	if (analys_msgrange (&(buffer [token_length]), &token_length, &msgrange) < 0)
	        {
		printf ("Erreur dans la reconnaissance du range du message\n");
		destroy_msgtype (&msgtype);
		return -1;
		}

	if (analys_msgbody (&(buffer [token_length]), &token_length, &msgbody) < 0)
	        {
		printf ("Erreur dans la reconnaissance du body du message\n");
		destroy_msgtype (&msgtype);
		destroy_msgrange (&msgtype);
		return -1;
		}

	printf ("\n");
	mesg = (struct message *) malloc (sizeof (struct message));
	mesg->msgtype = msgtype;
	mesg->msgrange = msgrange;
	mesg->msgbody = msgbody;

//	afficher_message ();
	return 0;
	}

int Struct_Buffer::buff_count (void)
        {
	struct maillon_buffer *maillon;
	int i = 1;

	maillon = buff;
	while (maillon != NULL)
	        {
		i++;
		maillon = maillon->next;
		}
	return i;
	}

void Struct_Buffer::buff_to_buffer (char *buffer)
        {
	int i = 0;
	struct maillon_buffer *maillon;

	maillon = buff;
	while (maillon != NULL)
	        {
		buffer [i] = maillon->car;
		maillon = maillon -> next;
		i++;
		}
	buffer [i] = '\0';
	}

int Message::convert_buff_to_mesg (void)
        {
	int lng;
	char *buffer;
	int result;

	if (buff == NULL)
	        {
		return -1;
		}

	destroy_message ();

	lng = buff_count ();
	buffer = (char *) malloc (lng * sizeof (char));
	buff_to_buffer (buffer);

	result = analys_msg (buffer);

	free (buffer);
	return result;
	}

struct Struct_Buffer::maillon_buffer *Struct_Buffer::maillon_malloc (void)
        {
	return (struct maillon_buffer *) malloc (sizeof (struct maillon_buffer));
	}

void Message::put_string (struct maillon_buffer **maillon, char *strng)
        {
	int i = 0;

	while (strng [i] == '\0')
	        {
		(*maillon)->next = maillon_malloc ();
		maillon = &((*maillon)->next);
		(*maillon)->car = strng [i];
		i++;
		}
	}

int Message::convert_mesg_to_buff (void)
        {
	struct maillon_buffer *maillon = NULL;
	struct maillon_message_field *maillon_body = NULL;

	if ((mesg == NULL)
	    || (mesg->msgtype == NULL)
	    || (mesg->msgrange == NULL)
	    || (mesg->msgbody == NULL)
	    || (mesg->msgbody->field_name == NULL)
	    || (mesg->msgbody->field_value == NULL)
	    )
	        {
		return -1;
		}

	destroy_buffer ();
	buff = maillon_malloc ();
	maillon = buff;
	maillon->car = *(mesg->msgtype);
	put_string (&maillon, "(");
	maillon->next = maillon_malloc ();
	maillon = maillon->next;
	maillon->car = *(mesg->msgrange);
	put_string (&maillon, ")\n\t{\n");
	maillon_body = mesg->msgbody;
	while (maillon_body != NULL)
	        {
		put_string (&maillon, "\t");
		put_string (&maillon, maillon_body->field_name);
		put_string (&maillon, " = \"");
		put_string (&maillon, maillon_body->field_value);
		put_string (&maillon, "\"\n");
		}
	put_string (&maillon, "\t}\n");
	maillon->next = NULL;
	last = maillon;

//	afficher_buffer ();
	return 0;
	}

void Struct_Buffer::add_char_to_buffer (char car)
        {
	if (buff == NULL)
	        {
		buff = maillon_malloc ();
		last = buff;
		buff->car = car;
		buff->next = NULL;
		}
	else
	        {
		last->next = maillon_malloc ();
		last->next->car = car;
		last->next->next = NULL;
		}
	}

void Struct_Buffer::add_string_to_buffer (char *str)
        {
	int i = 0;
	while (str [i] != '\0')
	        {
		add_char_to_buffer (str [i]);
		i++;
		}
	}





Message_Input::Message_Input (void)
        {
	mesg = NULL;
	buff = NULL;
	last = NULL;
	}

Message_Input::~Message_Input (void)
        {
	destroy_message ();
	destroy_buffer ();
	}

int Message_Input::read_from_input (class Socket *sock)
        {
	int res;

	if ((res = read_buffer_from_input (sock)) < 0)
	        {
		return res;
		}
	if ((res = convert_buff_to_mesg ()) < 0)
	        {
		return res;
		}
	return 0;
	}





Message_Output::Message_Output (void)
        {
	mesg = NULL;
	buff = NULL;
	last = NULL;
	}

Message_Output::~Message_Output (void)
        {
	destroy_message ();
	destroy_buffer ();
	}

int Message_Output::write_to_output (class Socket *sock)
        {
	int res;
	int lng;
	char *tmp;

	if ((res = convert_mesg_to_buff ()) < 0)
	        {
		return res;
		}

	lng = buff_count ();
	tmp = (char *) malloc (lng * sizeof (char));
	buff_to_buffer (tmp);

	if ((res = (*sock).write_string (tmp)) < 0)
	        {
		free (tmp);
		return res;
		}
	free (tmp);
	return 0;
	}






Socket::Socket (void)
        {
	init_connect ();
	}

Socket::~Socket (void)
        {
	close_connect ();
	}

void Socket::init_connect (void)
        {
	if ((main_socket = socket (AF_INET, SOCK_STREAM, 0)) < 0)
		{
		perror("Fatal error: Unable to open server's main socket");
		exit (1);
		}

	serv_name.sin_family = AF_INET;
	serv_name.sin_port = htons (atoi (SERV_PORT));
	if ((inet_aton (SERV_ADDR, &serv_name.sin_addr)) == 0)
		{
		close (main_socket);
		perror( "Fatal error: Server name incorrect");
		exit (3);
		}

	/*  
	printf ("DEBUG : ntohs (serv_name.sin_port) : ");
	printf ("%d\n", ntohs (serv_name.sin_port));
	printf ("DEBUG : ntohl (serv_name.sin_addr.s_addr) : ");
	printf ("%x\n\n", ntohl (serv_name.sin_addr.s_addr));
	*/
  
	if ((connect (main_socket, (struct sockaddr *)&serv_name, sizeof (serv_name))) < 0)
		{
		close (main_socket);
		perror( "Fatal error: Unable to connect to server");
		exit(4);
		}
	}

void Socket::close_connect (void)
        {
	if (main_socket != 0)
	        {
		close (main_socket);
		main_socket = 0;
		}
	}

int Socket::get_socket_fd (void)
        {
	return main_socket;
	}

int Socket::read_char (char *car)
        {
	if (read (main_socket, car, sizeof(char)) < 0)
	        {
		return -1;
		}
	else
	        {
	        return 0;
		}
	}

int Socket::write_string (char *str)
        {
	if (write (main_socket, str, strlen (str) + 1))
	        {
		return -1;
		}
	else
	        {
	        return 0;
		}
	}

int Socket::get_message_from_socket (class General_Message **g_mesg)
        {
	Message_Input mesg_in;

	if (mesg_in.read_from_input (this) < 0)
	        {
		return -1;
		}

	switch (*(mesg_in.get_type ()))
	        {
		case 'S':
		        {
			switch (*(mesg_in.get_range ()))
			        {
				case 'X':
				        {
					class X_Message *x_mesg;
					x_mesg = new X_Message ();
					(*x_mesg).define_type (*mesg_in.get_field_value ("type"));
					(*x_mesg).define_user (a_to_us (mesg_in.get_field_value ("user")));
					(*x_mesg).define_body (mesg_in.get_field_value ("body"));
					*g_mesg = x_mesg;
					}
				break;
				case 'P':
				        {
					return -1;
					}
				break;
				default:
				        {
					return -1;
					}
				break;
				}
			}
		break;
		case 'A':
		        {
			switch (*(mesg_in.get_range ()))
			        {
				case 'L':
				        {
					class Login_Answer *a_mesg;
					a_mesg = new Login_Answer ();
					(*a_mesg).define_answer (mesg_in.get_field_value ("answer"));
					*g_mesg = a_mesg;
					}
				break;
				case 'X':
				        {
					return -1;
					}
				break;
				default:
				        {
					return -1;
					}
				break;
				}
			}
		break;
		case 'G':
		        {
			switch (*(mesg_in.get_range ()))
			        {
				case 'I':
				        {
					return -1;
					}
				break;
				default:
				        {
					return -1;
					}
				break;
				}
			}
		break;
		default:
		        {
			return -1;
			}
		break;
		}

	return 0;
	}

unsigned short Socket::a_to_us (char *str)
        {
	int i = 0;
	unsigned short total = 0;

	while (str [i] != '\0')
	        {
		total = (total * 10) + (unsigned short) (str [i] - '0');
		i++;
		}

	return total;
	}





General_Message::General_Message (void)
        {
	}

General_Message::~General_Message (void)
        {
	}

char *General_Message::what (void)
        {
	return "General_Message";
	}









X_Message::X_Message (void)
        {
	type = '\0';
	user = 0;
	body = NULL;
	}

X_Message::~X_Message (void)
        {
	destroy_body ();
	}

char *X_Message::what (void)
        {
	return "X_Message";
	}

void X_Message::define_type (char ty)
        {
	type = ty;
	}

void X_Message::define_user (unsigned short us)
        {
	user = us;
	}

void X_Message::define_body (char *str)
        {
	int size;

	destroy_body ();
	size = strlen (str) + 1;
	body = (char *) malloc (size * sizeof (char));
	strcpy (body, str);
	}

char X_Message::get_type (void)
        {
	return type;
	}

unsigned short X_Message::get_user (void)
        {
	return user;
	}

int X_Message::get_body_size (void)
        {
	return strlen (body);
	// '\0' is not integrated in the size.
	}

void X_Message::get_body (char *str)
        {
	strcpy (str, body);
	}

int X_Message::send (class Socket *sck)
        {
	Message_Output msg;

	msg.new_message ('S', 'X');
	if (msg.add_field ("type", type) < 0)
	        return -1;
	if (msg.add_field ("user", user) < 0)
	        return -1;
	if (msg.add_field ("body", body) < 0)
	        return -1;
	if (msg.write_to_output (sck) < 0)
	        return -1;
	return 0;
	}

void X_Message::destroy_body (void)
        {
	if (body != NULL)
	        {
		free (body);
		body = NULL;
		}
	}






Login_Attempt::Login_Attempt (void)
        {
	login = NULL;
	password = NULL;
	}

Login_Attempt::~Login_Attempt (void)
        {
	destroy_login ();
	destroy_password ();
	}

void Login_Attempt::define_login (char *str)
        {
	int size;

	destroy_login ();
	size = strlen (str) + 1;
	login = (char *) malloc (size * sizeof (char));
	strcpy (login, str);	
	}

void Login_Attempt::define_password (char *str)
        {
	int size;

	destroy_password ();
	size = strlen (str) + 1;
	password = (char *) malloc (size * sizeof (char));
	strcpy (password, str);	
	}

int Login_Attempt::send (class Socket *sck)
        {
	Message_Output msg;

	msg.new_message ('S', 'L');
	if (msg.add_field ("login", login) < 0)
	        return -1;
	if (msg.add_field ("password", password) < 0)
	        return -1;
	if (msg.write_to_output (sck) < 0)
	        return -1;
	return 0;
	}

void Login_Attempt::destroy_login (void)
        {
	if (login != NULL)
	        {
		free (login);
		login = NULL;
		}
	}

void Login_Attempt::destroy_password (void)
        {
	if (password != NULL)
	        {
		free (password);
		password = NULL;
		}
	}







Login_Answer::Login_Answer (void)
        {
	answer = NULL;
	}

Login_Answer::~Login_Answer (void)
        {
	destroy_answer ();
	}

char *Login_Answer::what (void)
        {
	return "Login_Answer";
	}

void Login_Answer::define_answer (char *str)
        {
	int size;

	destroy_answer ();
	size = strlen (str) + 1;
	answer = (char *) malloc (size * sizeof (char));
	strcpy (answer, str);
	}

int Login_Answer::get_answer_size (void)
        {
	return strlen (answer);
	// '\0' is not integrated in the size.
	}

void Login_Answer::get_answer (char *str)
        {
	strcpy (str, answer);
	}

void Login_Answer::destroy_answer (void)
        {
	if (answer != NULL)
	        {
		free (answer);
		answer = NULL;
		}
	}












int main (void)
        {
	return 0;
	}

void terminate (void)
	{
	printf ("Ze termine\n");
	exit (0);
	}
