#ifndef __PROTOCOL__
#define __PROTOCOL__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <termios.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <arpa/inet.h>

class Protocol
        {
        private:
	struct maillon_message_field;

	struct maillon_message_field
                {
		char *field_name;
		char *field_value;
		struct maillon_message_field *next;
                };

	struct message
	        {
		char *msgtype;
		char *msgrange;
		struct maillon_message_field *msgbody;
                };

        private:
	struct message *mesg;

        public:
	Protocol (void);
	~Protocol (void);
	int analysis (char *);
	int analysis_login (char *, char **, char **);
	void afficher_message (void);

        private:
	void afficher_msgbody (struct maillon_message_field *);
	void destroy_msgtype (char **);
	void destroy_msgrange (char **);
	void destroy_string (char **);
	void destroy_maillon (struct maillon_message_field **);
	void destroy_msgbody (struct maillon_message_field **);
	void destroy_message (void);
	int next_token (char *);
	int chars (char);
	void new_token (char *, char *, int *);
	char token_analysis (char *);
	int analys_msgtype (char *, int *, char **);
	int analys_msgrange (char *, int *, char **);
	int analys_msgbody (char *, int *, struct maillon_message_field **);
	int analys_msg (char *, struct message **);
        };

#endif
