/* ***************************************************************** *
 * Atlantis BBS - CGI Parser                                         *
 * ----------------------------------------------------------------- *
 * Version . . . . . . . . . . . . . . . . . . . . . . . . . . 1.0.6 *
 * ================================================================= *
 * Creation date . . . . . . . . . . . . . . . . . . Wed 12 Aug 1998 *
 * Modification date . . . . . . . . . . . . . . . . Sun 17 Jan 1999 *
 * ================================================================= *
 * Copyright (C) 1997-1998 Free Software Foundation, Inc.            *
 *                                                                   *
 * This program  is  free software;  you can  redistribute it and/or *
 * modify it  under the terms  of the GNU  General Public License as *
 * published by  the Free Software Foundation;  either version 2, or *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program  is distributed in the hope  that it will be useful, *
 * but WITHOUT  ANY WARRANTY;  without even  the implied warranty of *
 * MERCHANTABILITY  or  FITNESS  FOR A  PARTICULAR PURPOSE.  See the *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along  with  this  program;  if not,  write to  the Free Software *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         *
 *                                                                   *
 * ================================================================= *
 * Authors                                                           *
 *   Sebastien APERGHIS-TRAMONI <saper@esil.univ-mrs.fr>             *
 *                                                                   *
 * If you find any bug, or if you do any improvment, please send us  *
 * a mail (possibly with diff and/or correction).                    *
 *                                                                   *
 * ***************************************************************** */


#ifndef CGI_PARSER_H
#define CGI_PARSER_H


/* ***************************************************************** *
 * typedefs                                                          *
 * ***************************************************************** */
typedef struct {
    char *  key;
    char *  value;
} HASH;


/* ***************************************************************** *
 * prototypes                                                        *
 * ***************************************************************** */
HASH *      expect          (int number);
char *      get_value       (HASH * data, char * key);
void        purge           (HASH * data);
int         parse           (HASH * data);

void        unescape        (char * str);
void        plus2space      (char * str);
void        space2plus      (char * str);

void        failure         (char * message);
int         print_file      (char * filename, FILE * stream);


#endif /* CGI_PARSER_H */
